----------------------------|
---Retro's Kart VR System---|
---Inspired by Pepperdork---|
----------------------------|

--Pretty sure everyone's tired of having to deal with roadblocks because
--other players forgot to afk
rawset(_G, "kvr_autospec" , CV_RegisterVar({
	name = "kvr_autospec",
	defaultvalue = "On",
	flags = CV_NETVAR,
	PossibleValue = CV_OnOff
}))

rawset(_G, "kvr_autospectimer" , CV_RegisterVar({
	name = "kvr_autospectimer",
	defaultvalue = "20",
	flags = CV_NETVAR,
	PossibleValue = {MIN = 20, MAX = 45}
}))

local starttime = 6*TICRATE + (3*TICRATE/4)


--Init
local function KVR_DataTable(p)
	p.kvrscore = 1000
	p.kvroldscore = 0
	p.kvrrank = 1
	p.kvrstr = 0
	p.kvredr = 0
	p.kvrwins = 0
	p.kvrlosses = 0
	p.kvrok = 0
	p.kvrwelcometimer = 0
	p.kvrpromotion = 0
	p.kvrdemotion = 0
	p.kvrwelcomeback = 0
	p.kvrpass = 0
	p.kvrpassed = 0
	p.kvrracescore = 0
	p.kvrpay = 0
	p.kvridle = 0
	p.kvrbase = 0
	p.kvravgdiff = 0
	p.kvrsubpay = 0
	p.kvrpendingrival = 0
	p.kvrrival = "none"
	p.kvrrivalmusic = 1
	p.kvrarchrivalmusic = 1
	p.kvrrivalwins = 0
	p.kvrrivallosses = 0
	p.kvrrivaldraws = 0
	p.kvrwager = 0
	p.kvrlastwager = 0
	p.hasbet = 0
	p.kvrlapmarker = 0
	p.kvrlap = 0
	p.kvrbestlap = 0
	p.hasrival = 0
	p.kvrtablepos = 0
	p.kvrbettier = 0
end

--Sync
rawset(_G, "KVR_Refresh", function(p)
	p.kvrscoreset = nil
	p.kvrpay = 0
	p.kvrbase = 0
	p.kvravgdiff = 0
	p.kvrsubpay = 0
	p.kvridle = 0
	p.kvrracescore = 0
	p.kvrpromotion = 0
	p.kvrdemotion = 0
	p.kvrpromoted = nil
	p.kvrdemoted = nil
	p.kvrstartset = nil
	p.kvrendset = nil
	p.kvriscore = nil
	p.kvrititle = nil
	p.kvrlapmarker = 0
	p.kvrlap = 0
	p.kvrbestlap = 0
	p.kvrtablepos = 0
end)


--Sets Rank, used in various other functions ahead
--THANK YOU ASHNAL AND MICENICE
rawset(_G, "KVR_RankTable", {9999, 9500, 8000, 6500, 5000, 4000, 3000, 2000, 1500, 500, 1})
rawset(_G,"KVR_Rank", function(p)
	for i=1, #KVR_RankTable do
		if p.kvrscore and (p.kvrscore >= KVR_RankTable[i]) then
			p.kvrrank = i
			break
		end
	end
end)


--Welcome (Back) Message
local function KVRWelcome(p)
	--print("Welcome? "..p.kvrwelcome.." Welcome back? "..p.kvrwelcomeback)
	if (not p.kvrwelcomed) then
		p.kvrwelcometimer = $+1
	end
	if p.kvrwelcometimer == 3*TICRATE then
		if (not p.kvrwelcome)
			if p.kvrwelcomeback == 1 then
				chatprintf(p,"*Hey, welcome back!", true)
			elseif p.kvrwelcomeback == 0 then
				chatprintf(p,"*This server runs the Kart VS Rating(KartVR) system. Enjoy your stay!", true)
				p.kvrwelcomeback = 1
			end
			chatprintf(p, "*Type !record, !rival, or !wager in chat for detailed info!", true)
			S_StartSound(nil, sfx_lvpass, p)
			p.kvrwelcome = 1
			--print("Welcome? "..p.kvrwelcome.." Welcome back? "..p.kvrwelcomeback)
		end
		p.kvrwelcomed = true
		--print("Welcome!")
	end
end


--Record-Keeping function: Accurately returns finish position, good for maps
--with jankpoints, like RAEX Super RR or Metal Harbor

rawset(_G, "kvrcalc", false) -- need to rawset this for SpeedSwitch.lua
local kvrrecords
local K_FinalPosition
rawset(_G, "KVR_Records", function(p)
	local LobbySize = KVR_playercount()	
	K_FinalPosition = p.kartstuff[k_position]
	local tophalf = FixedInt(FixedCeil(FixedDiv(LobbySize*FRACUNIT, 2*FRACUNIT)))
	
	if(p.pflags & PF_TIMEOVER) then
		local KVRTime = {}
		for t in players.iterate do
			if(t.pflags & PF_TIMEOVER and t.mo and t.mo.valid) then
				table.insert(KVRTime, t)
			end
		end
		
		table.sort(KVRTime, function(a,b)
			return a.realtime < b.realtime
		end)
		
		-- Now... find their position in the table
		for i=1, #KVRTime do
			if(#KVRTime[i] == #p) then
				K_FinalPosition = tophalf+i
				break
			end
		end
	else
		local KVRTime = {}
		for t in players.iterate do
			if (t.exiting > 0 and not(t.pflags & PF_TIMEOVER)) and (t.mo and t.mo.valid) then
				table.insert(KVRTime, t)
			end
		end
		
		table.sort(KVRTime, function(a,b)
			return a.realtime < b.realtime
		end)
		
		-- Now... find their position in the table
		for i=1, #KVRTime do
			if(#KVRTime[i] == #p) then
				K_FinalPosition = i
				break
			end
		end
	end
	
	--Adding Data to Racing Record
	if K_FinalPosition == 1 then
		p.kvrwins = $ + 1
		--print("Win recorded")
	elseif K_FinalPosition > 1 and K_FinalPosition <= tophalf then
		p.kvrok = $ + 1
		--print("OK recorded")
	elseif K_FinalPosition > tophalf then
		p.kvrlosses = $ + 1
		--print("Loss recorded")
	end
	p.kvrrecords = true
end)

--AFK Auto-Spec
local function KVR_AutoSpec(p)
	if not kvr_autospec.value then return end
	if not (p.mo and p.mo.valid) then return end
	if leveltime < starttime or p.spectator or p.playerstate ~= PST_LIVE or p.kartstuff[k_respawn] or p.kartstuff[k_spinouttimer] or p.kartstuff[k_wipeoutslow] or p.exiting then return end
	--if leveltime%TICRATE == 0
		--print("AFK TIMER: "..(p.kvridle/TICRATE))
	--end
	if (server)
		if (CV_FindVar("lb_afk") and CV_FindVar("lb_afk").value)
			COM_BufInsertText(server, "lb_afk off")
		end
	end

	if not p.cmd.buttons or p.speed <= 0 then
		p.kvridle = $+1
	else
		p.kvridle = max($-1, 0)
	end
	
	if p.kvridle >= (kvr_autospectimer.value)*TICRATE then
		p.spectator = true
		p.kvridle = 0
	end
end

--Sets In-Game Score to Rating
local function KVR_SetScore(p)
	p.score = p.kvrscore
	p.kvrscoreset = true
end

--Set Start Rank, 1st part of rank change check
local function KVR_StartRank(p)
	if (p.kvrrank == nil or p.kvrrank == 0) then return end
	p.kvroldscore = p.kvrscore
	--print("Oldscore: "..p.kvroldscore)
	p.kvrstr = p.kvrrank
	p.kvrstartset = true
	--print("Start Rank "..p.kvrstr)
end

--Set End Rank, 2nd part of rank change check
local function KVR_EndRank(p)
	if (p.kvrendset) then return end
	if not p.kvrendset then
		KVR_Rank(p)
		p.kvredr = p.kvrrank
		p.kvrendset = true
		--print("End Rank "..p.kvredr)
	end
end

--Determining Promotion/Demotion
local function KVR_Promotion(p)
	if p.kvredr < p.kvrstr and (p.kvredr ~= 0 and p.kvrstr ~= 0) then
		p.kvrpromotion = 1
	elseif p.kvredr > p.kvrstr and (p.kvredr ~= 0 and p.kvrstr ~= 0) then
		p.kvrdemotion = 1
	else
		p.kvrdemotion = 0
		p.kvrpromotion = 0
	end
		
	if p.kvrpromotion == 1 and not p.kvrpromoted then
		--chatprintf(p,"*".."\x84".."Rank Up! ".."\x80".."Your rank is now"..kvrrank_text[p.kvrrank].."\x80".."!")
		S_StartSound(p.mo, sfx_cgot, p)
		p.kvrpromoted = true
	elseif p.kvrdemotion == 1 and not p.kvrdemoted then
		--chatprintf(p,"*".."\x85".."Rank Down... ".."\x80".."Your rank is now"..kvrrank_text[p.kvrrank].."\x80"..".")
		S_StartSound(p.mo, sfx_bewar3, p)
		S_StartSound(p.mo, sfx_bewar3, p) -- HUEHUEHUE
		p.kvrdemoted = true
	else
		--Chat print after score tally
		if p.kvrpay > 0 then
			S_StartSound(p.mo, sfx_s1b5, p)
		elseif p.kvrpay < 0 then
			S_StartSound(p.mo, sfx_s1c6, p)
		end
	end
end

--Record-keeping function for SCORE.lua
local function KVRHandler(p)
	if (not netgame) then return end
	if(HasPlayerFinished(p) and KVR_playercount() > 1 and (not p.kvrrecords)) then
		KVR_Records(p)
	end
end


--We need to keep promotion and demotion stuff consistent, so name-swapping 
--during a race doesn't trigger unnecessary sounds post-race
local function KVR_DataFlush(p)
	if p.name ~= p.kvrlastname
		KVR_Refresh(p)
	end
	p.kvrlastname = p.name
end

--Attempting to recreate MKWii VR functions
-------------------------------------------------------------------------------
local KVR_DiffTable = 
	{6598,  4999,  3963,  3233,  2671,  2212,  1819,  1476,
      1168,   889,   633,   395,   174,   -34,  -231,  -418,
      -596,  -767,  -931, -1090, -1243, -1392, -1536, -1676,
     -1813, -1946, -2076, -2203, -2328, -2450, -2569, -2687,
     -2802, -2915, -3026, -3136, -3243, -3349, -3454, -3557,
     -3658, -3759, -3857, -3955, -4051, -4147, -4241, -4334,
     -4425, -4516, -4606, -4695, -4783, -4870, -4957, -5042,
     -5127, -5211, -5294, -5377, -5459, -5540, -5622, -5702,
     -5783, -5863, -5942, -6022, -6101, -6180, -6259, -6338,
     -6417, -6495, -6574, -6653, -6731, -6810, -6889, -6968,
     -7048, -7127, -7207, -7287, -7367, -7448, -7530, -7611,
     -7693, -7776, -7860, -7944, -8029, -8114, -8201, -8288,
     -8377, -8466, -8557, -8649, -8743, -8838, -8935, -9034,
     -9135, -9239, -9345, -9455, -9568, -9684, -9806, -9933}



local function KVR_RateCalc(diff)
	diff = min($, 6598)
	diff = max($, -9933)
	//print("Diff: "..diff)
	
	for i = 1, #KVR_DiffTable
		local j = #KVR_DiffTable - 1
		while i < j
			local k = max((i+j)/2, 1)
			if diff > KVR_DiffTable[k] then
				j = k-1
			elseif diff <= KVR_DiffTable[k+1] then
				i = k+1
			else
				return k+1
			end
		end
		return i+1
	end
end

-------------------------------------------------------------------------------

--Who doesn't love a friendly wager between rivals?
local function kvr_wagerpayout(p)
	if not p.kvrpendingrival then return end
	if (p.kvrpendingrival and players[p.kvrpendingrival-1].spectator) then return end
	if p.kvrwager and players[p.kvrpendingrival-1].kvrwager then
		if p.realtime < players[p.kvrpendingrival-1].realtime or (not (p.pflags & PF_TIMEOVER) and (players[p.kvrpendingrival-1].pflags & PF_TIMEOVER)) and ((not p.spectator) and (not players[p.kvrpendingrival-1].spectator))then
			--print(p.name..": "..p.kvrracescore.."+"..players[p.kvrpendingrival-1].kvrwager)
			p.kvrracescore = $ + players[p.kvrpendingrival-1].kvrwager
		elseif p.realtime > players[p.kvrpendingrival-1].realtime or (p.pflags & PF_TIMEOVER) then
			--print(p.name..": "..p.kvrracescore.."-"..p.kvrwager)
			p.kvrracescore = $ - p.kvrwager
		end
	end
end

--Because I have no fucking clue how hardcode determines best lap during RA
local function KVR_laprecord(p)
	if p.laps == nil then p.laps = 0 end
	if p.laps >= 1
		if p.laps > p.lastlaps
			p.kvrlap = p.realtime - p.kvrlapmarker
			if (p.kvrlap < p.kvrbestlap or p.kvrbestlap == 0)
				p.kvrbestlap = p.kvrlap
				--chatprintf(p, "New best lap!"..buildTimeString(p.kvrbestlap))
			end
			p.kvrlapmarker = p.realtime
		end
	end
	p.lastlaps = p.laps
end

addHook("MapLoad", function()
	kvrcalc = false
	for p in players.iterate
		p.kvrrecords = false
		KVR_Refresh(p)
		KVR_Rank(p)
	end
end)


addHook("ThinkFrame", function()
	if leveltime < 1 return end
	local lobby = KVR_playercount()
	for p in players.iterate
		if p and p.valid and not p.kvrinit then
			KVR_DataTable(p)
			p.kvrinit = true
		end
		
		if not p.mo or not p.mo.valid or p.spectator then continue end
		if not p.kvrwelcomed then
			KVR_Rank(p)
			KVRWelcome(p)
		end
		
		KVR_Rank(p)
		KVRHandler(p)
		KVR_AutoSpec(p)
		
		if leveltime >= 236
			KVR_laprecord(p)
		end
		
		if(p.mo and p.mo.valid and not p.spectator) then
			p.fakeskin = p.mo.skin
		end

		if server.kvrfinishstate then -- detects custom intermission state
			--KVR_Promotion(p)
			if p.kvrwelcomed then
				p.kvrwelcomeback = 1
			end
			if not p.kvrscoreset then KVR_SetScore(p) end
		end
		KVR_DataFlush(p)
	end	
	
-----Point Calculation during race - GOD BLESS YOU TYRON------------------------
	local payout = 0
	for p in players.iterate
		if leveltime < starttime then continue end
		if p.kvrwelcomed then -- hacky way to prevent unnecessary rank change messages
			if (not p.kvrstartset) then
				KVR_StartRank(p)
			end
		end
	end
	
	--Everyone's done; calculate final payout
	if allfinished() then
		if not kvrcalc then
			for p in players.iterate
				if not hellavalid(p) then continue end
				p.kvrracescore = 0
				p.kvrpass = 0
				p.kvrpassed = 0
				for q in players.iterate
					if not hellavalid(q) then continue end
					if p == q then continue end
					if p.realtime < q.realtime or (not (p.pflags & PF_TIMEOVER) and (q.pflags & PF_TIMEOVER)) then
						p.kvrracescore = $ + (KVR_RateCalc(p.kvroldscore-q.kvroldscore))
						--print("Subtotal: "..p.kvrracescore)
					elseif p.realtime > q.realtime or (p.pflags & PF_TIMEOVER) then
						p.kvrracescore = $ - (KVR_RateCalc(q.kvroldscore-p.kvroldscore))
						--print("Subtotal: "..p.kvrracescore)
					end
				end	

				--Factoring Rivalry wagers
				if (p.kvrpendingrival and players[p.kvrpendingrival-1].kvrpendingrival-1 == #p)
				and not (p.spectator or players[p.kvrpendingrival-1].spectator)
				and (p.kvrwager and players[p.kvrpendingrival-1].kvrwager)
					if p.realtime < players[p.kvrpendingrival-1].realtime or (not (p.pflags & PF_TIMEOVER) and (players[p.kvrpendingrival-1].pflags & PF_TIMEOVER)) and ((not p.spectator) and (not players[p.kvrpendingrival-1].spectator))then
						--print(p.name..": "..p.kvrracescore.."+"..players[p.kvrpendingrival-1].kvrwager)
						p.kvrracescore = $ + players[p.kvrpendingrival-1].kvrwager
					elseif p.realtime > players[p.kvrpendingrival-1].realtime or (p.pflags & PF_TIMEOVER) then
						--print(p.name..": "..p.kvrracescore.."-"..p.kvrwager)
						p.kvrracescore = $ - p.kvrwager
					end
				end

				--Score tally
				payout = p.kvrracescore
				--print("Grand Total: "..payout)-- Rewards lower-rated players while setting reasonable expectations on higher-rated players
--------------------------------------------------------------------------------
				--Finalized Scores
				local finalscore = 0
				finalscore = p.kvrscore + payout
				p.kvrscore = max(finalscore, 1)
				p.kvrscore = min($, 9999)
				p.score = p.kvrscore
				p.kvrpay = payout
				--print(p.kvrpay)
				KVR_EndRank(p)
				if p.kvrstr ~= p.kvredr then
					p.kvrititle = leveltime+TICRATE
					--print(p.kvrititle.."/"..leveltime)
				end
				if p.kvrscore ~= p.kvroldscore then
					p.kvriscore = leveltime+TICRATE
					--print(p.kvriscore.."/"..leveltime)
				end
				kvrcalc = true
				--print("Start: "..p.kvrstr.." End: "..p.kvredr)
				KVR_Promotion(p)
			end	
		end
	end
end)

addHook("IntermissionThinker", function()
	for p in players.iterate
		if (HOSTMOD and CV_FindVar("kvr_intermission")) then return end
		if p.kvrwelcomed then
			p.kvrwelcomeback = 1
		end
		if not p.kvrscoreset then KVR_SetScore(p) end
	end
end)