-- KartVR HUD, inspired by CGB's FreshKart by DarkyBenji

rawset(_G, "kvr_hud" , CV_RegisterVar({
	name = "kvr_hud",
	defaultvalue = "On",
	flags = 0,
	PossibleValue = CV_OnOff
}))

local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local countdown = 3*TICRATE
local k_hyudorotimer = k_hyudorotimer
local k_invincibilitytimer = k_invincibilitytimer
local ORIG_FRICTION = 62914

local medal_colors = {
	[11] = SKINCOLOR_WHITE,
	[10] = SKINCOLOR_BROWN,
	[9] = SKINCOLOR_ORANGE,
	[8] = SKINCOLOR_NICKEL,
	[7] = SKINCOLOR_GOLD,
	[6] = SKINCOLOR_PLATINUM,
	[5] = SKINCOLOR_JAWZ,
	[4] = SKINCOLOR_GREEN,
	[3] = SKINCOLOR_CYAN,
	[2] = SKINCOLOR_TEA,
	[1] = SKINCOLOR_PURPLE
}

local kvr_colors = {
	[1] = 50,
	[2] = 87,
	[3] = 6,
	[4] = 107,
	[5] = 225,
	[6] = 0,
	[7] = 160,
	[8] = 210,
	[9] = 176,
	[10] = 198
}

--Don't mind me, just gonna take that from DriftGauge
local splitplayers = {}
local function splitnum(p)
	for i = 1, #splitplayers do
		if splitplayers[i] == p then
			return i-1
		end
	end
end

local kvr_textcolors = {
	[11] = "\x80",
	[10] = "\x8E",
	[9] = "\x87",
	[8] = "\x86",
	[7] = "\x8A",
	[6] = "\x8C",
	[5] = "\x80",
	[4] = "\x83",
	[3] = "\x88",
	[2] = "\x8B",
	[1] = "\x81"
}

local kvr_numcolors = {
	[11] = SKINCOLOR_WHITE,
	[10] = SKINCOLOR_BROWN,
	[9] = SKINCOLOR_ORANGE,
	[8] = SKINCOLOR_NICKEL,
	[7] = SKINCOLOR_GOLD,
	[6] = SKINCOLOR_STEEL,
	[5] = SKINCOLOR_WHITE,
	[4] = SKINCOLOR_GREEN,
	[3] = SKINCOLOR_CYAN,
	[2] = SKINCOLOR_TEA,
	[1] = SKINCOLOR_PURPLE
}


local ranknum = {}
for i = 0, 9
	ranknum[i] = "OPPRNK0"..i
end

-- ported from v_vid
local function V_drawPeggedRankNum(v, x, y, num, digits, flags, cmap)

	flags = $ or 0
	digits = $ or 1

	num = abs($)	-- negative unsupported

	while digits or num

		local curpatch = v.cachePatch(ranknum[num%10])
		local w = curpatch.width

		if flags & V_NOSCALESTART then
			w = $*v.dupx
		end

		x = $- (w-1)	-- need intersect
		v.draw(x, y, curpatch, flags, cmap)
		num = $/10
		digits = $-1
	end
end

local pingnum = {}
for i = 0, 9
	pingnum[i] = "PINGN"..i
end

-- ported from v_vid
local function V_drawPeggedPingNum(v, x, y, num, digits, flags, cmap)

	flags = $ or 0
	digits = $ or 1

	num = abs($)	-- negative unsupported

	while digits or num

		local curpatch = v.cachePatch(pingnum[num%10])
		local w = curpatch.width

		if flags & V_NOSCALESTART then
			w = $*v.dupx
		end

		x = $- (w-1)	-- need intersect
		v.draw(x, y, curpatch, flags, cmap)
		num = $/10
		digits = $-1
	end
end

hud.add(function(v, p, c) 
	if leveltime < 1 return end
	if not p.kvrscore then return end
	local count = KVR_playercount()
	if (not kvr_hud.value) or (G_BattleGametype()) or not (p.mo and p.mo.valid) then
		if not hud.enabled("speedometer") then 
			hud.enable("speedometer")
		end
		return 
	end
	
	local Snapflag = V_HUDTRANS
	local fx, fy = 0, 0
	local kvrmedal = "NEEDIT"
	if p.kvrrank then kvrmedal = "GOTITFRSH" end
	splitplayers[#splitplayers+1] = p

	if splitscreen == 0 then
		Snapflag = $ + V_SNAPTOBOTTOM|V_SNAPTOLEFT
		fx = 19
		fy = 154

		if (CV_FindVar("kartdisplayspeed").value) then
			local Speedometer, SpeedometerName
			if (CV_FindVar("kartdisplayspeed").value == 1) then // Kilometers
				v.draw(fx-12, fy-7, v.cachePatch("K_MBFRSH"), Snapflag)
				Speedometer = FixedDiv(FixedMul(p.speed, 142371), mapobjectscale)/FRACUNIT
				SpeedometerName = "K_MKMH"
			elseif (CV_FindVar("kartdisplayspeed").value == 2) then // Miles
				v.draw(fx-12, fy-7, v.cachePatch("K_MBFRSH"), Snapflag)
				Speedometer = FixedDiv(FixedMul(p.speed, 88465), mapobjectscale)/FRACUNIT
				SpeedometerName = "K_MMPH"
			elseif (CV_FindVar("kartdisplayspeed").value == 3) then // Fracunits
				v.draw(fx-12, fy-7, v.cachePatch("K_MBFRSH"), Snapflag)
				Speedometer = FixedDiv(p.speed, mapobjectscale)/FRACUNIT
				SpeedometerName = "K_MFUT"
			elseif (CV_FindVar("kartdisplayspeed").value == 4) then // Percent
				v.draw(fx-12, fy-7, v.cachePatch("K_SBFRSH"), Snapflag)
				Speedometer = (FixedDiv(p.speed, FixedMul(K_GetKartSpeed(p, false), ORIG_FRICTION))*100)>>FRACBITS
				SpeedometerName = "K_MPER"
			end
			V_drawPeggedRankNum(v, fx+18, fy-9, Speedometer, 3, Snapflag)
			v.draw(fx+22, fy-9, v.cachePatch(SpeedometerName), Snapflag)
			hud.disable("speedometer")
		end
		
		v.draw(fx-12, fy+8, v.cachePatch("K_BBFRSH"), Snapflag)
		v.draw(fx, fy, v.cachePatch(skins[p.mo.skin].facerank), Snapflag, v.getColormap(p.mo.skin, p.skincolor))

		//Score
		if p.kvriscore and (leveltime < p.kvriscore) then
			if ((leveltime % 2) == 0) then
				//print(p.kvrpay)
				//v.drawString(fx+60, fy+5, ""..(p.fresh.score).."", Snapflag, "thin")
				V_drawPeggedPingNum(v, fx+75, fy+6, p.kvrscore, 4, Snapflag, v.getColormap(TC_RAINBOW, kvr_numcolors[p.kvrrank]))
				if allfinished() and count >= 2 then
					if p.kvrpay > 0 then
						v.drawString(fx+77, fy+5, "\x82 +"..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
					elseif p.kvrpay < 0 then
						v.drawString(fx+77, fy+5, "\x85 "..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
					end
				end
			end
		else
			//v.drawString(fx+60, fy+5, ""..(p.fresh.score).."", Snapflag, "thin")
			V_drawPeggedPingNum(v, fx+75, fy+6, p.kvrscore, 4, Snapflag, v.getColormap(TC_RAINBOW, kvr_numcolors[p.kvrrank]))
			if allfinished() and count >= 2 then
				if p.kvrpay < 0 then
					v.drawString(fx+77, fy+5, "\x85 "..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
				elseif p.kvrpay > 0 then
					v.drawString(fx+77, fy+5, "\x84 +"..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
				end
			end
		end
		
		//Title
		if p.kvrititle and (leveltime < p.kvrititle) then
			if ((leveltime % 2) == 0) then
				v.drawString(fx+20, fy, ""..kvrrank_text[p.kvrrank].."", V_ALLOWLOWERCASE|Snapflag, "small")
				v.drawScaled((fx+18)*FRACUNIT, (fy+6)*FRACUNIT, FRACUNIT/2, v.cachePatch(kvrmedal), Snapflag, v.getColormap(-1, medal_colors[p.kvrrank]))
			end
		else
			v.drawString(fx+20, fy, ""..kvrrank_text[p.kvrrank].."", V_ALLOWLOWERCASE|Snapflag, "small")
			v.drawScaled((fx+18)*FRACUNIT, (fy+6)*FRACUNIT, FRACUNIT/2, v.cachePatch(kvrmedal), Snapflag, v.getColormap(-1, medal_colors[p.kvrrank]))
		end
		
		//I wouldn't made this far without driftgauge by Lat'
		if leveltime > countdown then
			v.drawFill(fx+29, fy+9, 28, 3, 23|Snapflag)
			local kvrlimit, kvrlevel, startat
			local kvrvalue = min(p.kvrscore, 9999)
			kvrvalue = max(p.kvrscore, 1)

			if kvrvalue <= 500 then
				kvrlevel = 1
				kvrlimit = 500
				startat = 0
			elseif kvrvalue <= 1500 then
				kvrlevel = 2
				kvrlimit = 1500
				startat = 500
			elseif kvrvalue <= 2000 then
				kvrlevel = 3
				kvrlimit = 2000
				startat = 1500
			elseif kvrvalue <= 3000 then
				kvrlevel = 4
				kvrlimit = 3000
				startat = 2000
			elseif kvrvalue <= 4000 then
				kvrlevel = 5
				kvrlimit = 4000
				startat = 3000
			elseif kvrvalue <= 5000 then
				kvrlevel = 6
				kvrlimit = 5000
				startat = 4000
			elseif kvrvalue <= 6500 then
				kvrlevel = 7
				kvrlimit = 6500
				startat = 5000
			elseif kvrvalue <= 8000 then
				kvrlevel = 8
				kvrlimit = 8000
				startat = 6500
			elseif kvrvalue <= 9500 then
				kvrlevel = 9
				kvrlimit = 9500
				startat = 8000
			elseif kvrvalue <=9999 then
				kvrlevel = 10
				kvrlimit = 9999
				startat = 9500
			end
			
			if kvr_colors[kvrlevel-1] ~= nil then
				for i = 1, 3
					local newbarcolor = kvr_colors[kvrlevel-1] + (i-1)*3
					v.drawFill(fx+29, (fy+7) + 1 + i, 28, 1, newbarcolor|Snapflag)
				end
			end

			local barlength = (kvrvalue-startat)*28 / (kvrlimit-startat)
			local barcolor = kvr_colors[kvrlevel]
			
			for i = 1, 3
				local newbarcolor = barcolor + (i-1)*3
				v.drawFill(fx+29, (fy+7) + 1 + i, barlength, 1, newbarcolor|Snapflag)
			end
		end
	elseif splitscreen == 1 then
		Snapflag = $ + V_SNAPTOLEFT
		if splitnum(p) then
			Snapflag = V_SPLITSCREEN|V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT
		end
		
		fx = 19
		fy = 118/2
		
		v.draw(fx-12, fy+8, v.cachePatch("K_MBFRSH"), Snapflag)
		v.draw(fx, fy, v.cachePatch(skins[p.mo.skin].facerank), Snapflag, v.getColormap(p.mo.skin, p.skincolor))

		//Score
		if p.kvriscore and (leveltime < p.kvriscore) then
			if ((leveltime % 2) == 0) then
				V_drawPeggedRankNum(v, fx+56, fy+6, p.kvrscore, 4, Snapflag, v.getColormap(TC_RAINBOW, kvr_numcolors[p.kvrrank]))
				if allfinished() and (count >= 2) then
					if p.kvrpay < 0 then
						v.drawString(fx+58, fy+5, "\x85 "..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
					elseif p.kvrpay > 0 then
						v.drawString(fx+58, fy+5, "\x84 +"..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
					end
				end
			end
		else
			V_drawPeggedRankNum(v, fx+56, fy+6, p.kvrscore, 4, Snapflag, v.getColormap(TC_RAINBOW, kvr_numcolors[p.kvrrank]))
			if allfinished() and (count >= 2) then
				if p.kvrpay < 0 then
					v.drawString(fx+58, fy+5, "\x85 "..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
				elseif p.kvrpay > 0 then
					v.drawString(fx+58, fy+5, "\x84 +"..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
				end
			end
		end
		
		//Title
		if p.kvrititle and (leveltime < p.kvrititle) then
			if ((leveltime % 2) == 0) then
				v.drawString(fx+20, fy, ""..kvrrank_text[p.kvrrank].."", V_ALLOWLOWERCASE|Snapflag, "small")
				v.drawScaled((fx+19)*FRACUNIT, (fy+6)*FRACUNIT, FRACUNIT/2, v.cachePatch(kvrmedal), Snapflag, v.getColormap(-1, medal_colors[p.kvrrank]))
			end
		else
			v.drawString(fx+20, fy, ""..kvrrank_text[p.kvrrank].."", V_ALLOWLOWERCASE|Snapflag, "small")
			v.drawScaled((fx+19)*FRACUNIT, (fy+6)*FRACUNIT, FRACUNIT/2, v.cachePatch(kvrmedal), Snapflag, v.getColormap(-1, medal_colors[p.kvrrank]))
		end

	elseif splitscreen > 1 then
		Snapflag = $ + V_SNAPTOLEFT
		if splitnum(p) == 1 then
			Snapflag = V_HUDTRANS|V_HORZSCREEN|V_SNAPTORIGHT
		elseif splitnum(p) == 2 then
			Snapflag = V_SPLITSCREEN|V_HUDTRANS|V_SNAPTOBOTTOM|V_SNAPTOLEFT
		elseif splitnum(p) == 3 then
			Snapflag = V_SPLITSCREEN|V_HUDTRANS|V_HORZSCREEN|V_SNAPTOBOTTOM|V_SNAPTORIGHT
		end
		
		fx = 12/2
		if splitnum(p) == 1 or splitnum(p) == 3 then
			fx = 234/2
		end
		fy = 154/2
		
		//Score
		if p.kvriscore and (leveltime < p.kvriscore) then
			if ((leveltime % 2) == 0) then
				v.drawString(fx+10, fy, ""..kvr_textcolors[p.kvrrank]..""..(p.kvrscore).."", Snapflag, "left")
				if allfinished() and (count >= 2) then
					if p.kvrpay < 0 then
						v.drawString(fx+8, fy-10, "\x85 "..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
					elseif p.kvrpay > 0 then
						v.drawString(fx+8, fy-10, "\x84 +"..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
					end
				end
			end
		else
			v.drawString(fx+10, fy, ""..kvr_textcolors[p.kvrrank]..""..(p.kvrscore).."", Snapflag, "left")
			if allfinished() and (count >= 2) then
				if p.kvrpay < 0 then
					v.drawString(fx+8, fy-10, "\x85 "..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
				elseif p.kvrpay > 0 then
					v.drawString(fx+8, fy-10, "\x84 +"..(p.kvrpay).."", V_ALLOWLOWERCASE|Snapflag, "thin")
				end
			end
		end
		
		//Medal
		if p.kvrititle and (leveltime < p.kvrititle) then
			if ((leveltime % 2) == 0) then
				//v.draw(fx+8, fy+6, v.cachePatch("K_SMFRSH"), Snapflag, v.getColormap(-1, medal_colors[p.fresh.title]))
				v.drawScaled((fx)*FRACUNIT, (fy)*FRACUNIT, FRACUNIT/2, v.cachePatch(kvrmedal), Snapflag, v.getColormap(-1, medal_colors[p.kvrrank]))
			end
		else
			//v.draw(fx+8, fy+6, v.cachePatch("K_SMFRSH"), Snapflag, v.getColormap(-1, medal_colors[p.fresh.title]))
			v.drawScaled((fx)*FRACUNIT, (fy)*FRACUNIT, FRACUNIT/2, v.cachePatch(kvrmedal), Snapflag, v.getColormap(-1, medal_colors[p.kvrrank]))
		end
	end

	-- flush table
	if #splitplayers > splitscreen then
		splitplayers = {}
	end
end)