//trying to make a custom intermission scoreboard by basing it off the neo scoreboard.lua --freeman#7626
//thank you snu and tyron because without your existing work I probably would have never figured this out

//WHAT YOU NEED TO KNOW FOR INTEROPERABILITY IS THE FOLLOWING:
//this script will hold everyone in statis when it thinks the round ends
//and will effectively avoid doing intermisison at all until its done
//this means INTERMISSION THINKERS WONT RUN BEFORE THIS AND THEY CANT
//handle whatever you need to before intermission. These are the rawsets to do it:

//hm_intermissioncalc - Returns true the tic that this custom intermission starts
//use it to make a final calculation of all of your awards you want to add

//hm_addaward(title, description, player, weight, bonuspoints)
//Adds an award to the table of awards to be picked from. Awards are picked
//at random using weight as a factor of how likely it is to be picked. I highly
//suggest your awards calculate their weight based on how standout the number is.
//Title, Description can both use color codes. Descriptions are auto wrapped.
//Player is the player getting it. Using hm_addaward twice adds the award to the table twice,
//so don't do that unless you want it getting picked twice.
//bonus points is half implemented, will add points to server score if award is given.

//hm_resultsautotrigger (true/false)
//This is a rawset that you can change in any other script. If you are writing
//stuff for an alternative gamemode that doesn't have normal race exit conditions,
//you can stop this script from trying to auto-trigger results when it thinks
//everyone is done. Instead, you'll handle your own exit logic and then...

//hm_forcetriggerresults
//running this function forces this script to hold everyone in stasis and run
//its intermission. You can use it with the above to make your own exit conditions.

//notes about the award drawing at the end:
//the picking function only picks 5 awards cause that's all that will fit really
//the drawer will only keep drawing stuff until it gets down to about 170 pixels,
//then it automatically stops trying to draw more stuff off-screen. Its not broken,
//its just to stop the scoreboard from looking ugly.

//RetroStation Notes:
//Edited some of the scoreboard logic to tie directly to the KartVR system.
//Just looking to see how using a custom scoreboard looks instead of the usual
//console print I'd been using

local kvr_intermission = CV_RegisterVar({
	name = "kvr_intermission",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local kvr_inttime = CV_RegisterVar({
	name = "kvr_inttime",
	defaultvalue = 20,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
})

local kvr_bloopers = CV_RegisterVar({
	name = "kvr_bloopers",
	defaultvalue = "Off",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local awards = {}
local chosenawards = {}

local starttime = 6*TICRATE + (3*TICRATE/4) // leveltime when race actually starts (~235)
local introtime = 108+5 // leveltime when countdown, pre starttime, starts

//just for future reference I could not for the life of me grasp why comments below
//the above line wouldn't appear in the comment font until I spaced some stuff
//and it would reset every time I saved the thing and it literally drove me insane for several days

//only now have I figured out that using '"' to get a double quote in the time string
//was being interpreted as an open quote so nothing after it would be interpreted as a comment
//using the ascii dec code of "\34" has effectively resolved this abomination

--add an award title and description to be printed (include color codes if you want it colored)
--description will auto-wrap when printed (may cut off color codes)
--include the player who will be displayed as receiving it
--if this player disappears when the award is drawn, the award will be removed
--weight determines how likely the award is to appear, higher is more likely
--it is probably best to base your weight off a numerical function of whatever stat you are tracking so real stand-outs show up
--unless you want to give an award out multiple times, try to only award one player when you decide who to give it to
local function KVR_AddAward(title, desc, pl, weight, bonuspoints)
	if type(title) != "string" then error("KVR_AddAward error: arg 1 title expected string, got "..type(title)) return end
	if type(desc) != "string" then error("KVR_AddAward error: arg 2 desc expected string, got "..type(desc)) return end
	if pl == nil then return end
	if type(pl) != "userdata" then error("KVR_AddAward error: arg 3 pl expected userdata/player, got "..type(pl)) return end
	if type(weight) != "number" then error("KVR_AddAward error: arg 4 weight expected number, got "..type(weight)) return end
	if type(bonuspoints) != "number" then bonuspoints = 0 end
	local handled = false
	for i, k in pairs(awards)
		if awards[i].title == title then
			//print("HM_AddAward already has award for "..title..", overwriting...")
			awards[i] = {title=title, desc=desc, pl=pl, weight=weight, bonuspoints=bonuspoints}
			//print("HM_AddAward new value for "..title.." is: "..desc..", "..pl.name..", "..weight)
			handled = true
		end
	end
	if not handled then
		//print("HM_AddAward adding new award for "..title..": "..desc..", "..pl.name..", "..weight)
		table.insert(awards, {title=title, desc=desc, pl=pl, weight=weight})
	end
	if bonuspoints > 0 then
		pl.score = $+bonuspoints
	end
end


//this works off a weighted picker imitated from choose.lua
//props to tyron or whomever wrote that for demonstrating a way that this can work
local function chooseawards(awards, amt)
	//print("Attempting to pick awards: ("..amt..")")
	if not awards then
		error("chooseawards was passed without a table to choose awards from, aborting...")
		return
	elseif type(awards) != "table" then
		error("chooseawards wasn't provided a table, aborting...")
		return
	elseif not amt or type(amt) != "number" then
		error("chooseawards amount was invalid, aborting...")
		return
	end
	local allawards = awards
	if #awards <= amt then
		//print("Not enough awards to bother picking from, returning the whole list...")
		return awards
	end //lol
	local pickedawards = {}
	local weights = {}
	local totalweight = 0
	local index = 0
	//print("Setting up award pickertables...")
	while index < #allawards
		index = $ + 1
		table.insert(weights, awards[index].weight)
		totalweight = $ + awards[index].weight
		//print("Added "..awards[index].title.." to table (wgt: "..awards[index].weight.."), total weight now "..totalweight)
	end
	//print("Finished index, total weight: "..totalweight.." for "..#weights.." total awards")
	while #pickedawards < amt do
		//print("Top of while loop, picked so far is "..#pickedawards)
		local target = P_RandomRange(1, totalweight)
		//print("Target number now "..target)
		//print("awards to pick from right now:")
		for i=1, #allawards
			//print(allawards[i].title)
		end
		for k, v in ipairs(weights) do
			if #pickedawards >= amt then return pickedawards end
			//print("Checking "..target.." versus weight "..weights[k])
			if target <= tonumber(weights[k]) then
				table.insert(pickedawards, allawards[k])
				totalweight = $-weights[k]
				table.remove(allawards, k)
				table.remove(weights, k)
				target = P_RandomRange(1, totalweight)
				//print("Pick valid, new total weight is "..totalweight..", new target number is "..target.." and remaining awards is "..#allawards)
				break
			end
			target = $ - weights[k]
			//print("Pick not valid, old target subtracted by "..weights[k]..", new target now "..target)
		//print("Reached end of for loop, exiting...")
		end
	//print("reached end of while loop, goin back")
	end
	//print("exited while loop, returning sauce")
	return pickedawards
end

//you can use this to enable/disable this script from trying to auto-detect round end
//if you have specific end conditions that this script can't detect, set this to false and use force trigger
rawset(_G, "KVR_ResultsAutoTrigger", true) 

//a lot of this is imitated from snu's TSR checks for finish
//this does a generic check for exiting players and tries to trigger results when it thinks the game is over
local function KVR_tryTriggerResults()
	if not KVR_ResultsAutoTrigger then return end
	if server.kvrfinishstate then return end
	local pdone, ptotal = 0, 0
	for p in players.iterate
		if not p.spectator then ptotal = $+1 end
		if p.exiting and p.exiting < 8 then p.exiting = 8 end
		if (p.exiting and p.exiting == 8) or (p.pflags&PF_TIMEOVER) then
			if not p.spectator then pdone = $+1 end
		end
	end
	if not ptotal then return end
	if (pdone >= ptotal or exitcountdown == 8) and not server.kvrfinishstate then
		local intermissiontime = CV_FindVar("kvr_inttime").value*TICRATE
		K_SetExitCountdown(TICRATE*6000)
		server.kvrfinishstate = true
		server.kvrfinishtimer = intermissiontime
		for p in players.iterate if p and p.valid then
			p.exiting = 8
			p.powers[pw_nocontrol] = intermissiontime
		end end
	end
end

//if your game mode has exit conditions this script won't readily detect, use this
//to force the results to trigger after you've handled what you need to
rawset(_G, "KVR_forceTriggerResults", function()
	if not kvr_intermission.value then
		G_ExitLevel()
		error("A script tried to force trigger hostmod results, but kvr_intermission isn't on, running G_ExitLevel() instead...")
		return
	end
	local intermissiontime = CV_FindVar("kvr_inttime").value*TICRATE
	for p in players.iterate
		if p and p.valid then
			p.exiting = 8
			p.powers[pw_nocontrol] = intermissiontime
		end
	end
	server.kvrfinishstate = true
	server.kvrfinishtimer = intermissiontime
	K_SetExitCountdown(TICRATE*6000)
end)

local function KVR_handleFinish()
	if not server.kvrfinishstate then return end
	server.kvrfinishtimer = $-1
	K_SetExitCountdown(TICRATE*6000)
	if server.kvrfinishtimer == 0 then
		G_ExitLevel()
	end
end

addHook("IntermissionThinker", function()
	if server.kvrintermissionthinked then return end
	server.kvrfinishstate = false
	server.kvrfinishtimer = 0
	//if server.hmstoredinttime then
		//COM_BufAddText(server, "inttime "..server.hmstoredinttime)
		//server.hmstoredinttime = nil
	//end
	awards = {}
	server.kvrintermissionthinked = true
end)

local function KVR_interinit(p)
	if p and p.valid and not p.kvrintinit then
		
		p.kvrfrontruntime = 0 //tics in position 1
		p.kvroffroadtime = 0 //tics spent in offroad
		p.kvrnocontroltime = 0 //tics spent out of control (falling, crushed, spunout, ect)
		p.kvrspinlastx = 0
		p.kvrspinlasty = 0
		p.kvrspinlastz = 0
		p.kvrspinoutdist = 0 //(for comparison to current pos which will be added here)
		p.kvrbananahits = 0 //number of bananas player hit this race
		p.kvrtspinouts = 0 //total times spun out
		p.kvrorbithits = 0 //times hit orbiting items
		p.kvrorbinauthits = 0 -- Times you've hit other players w/ Orbinauts
		p.kvrairtime = 0 -- Time spent in the air
		p.kvrfinishpoints = 0
		p.kvrwar = 0 -- Times you've hit people with items
		p.kvrboom = 0 -- Times you've nailed players with explosives
		p.kvrwall = 0 -- Times you've hit a wall
		p.kvrbig = 0 -- Time you've squished people
		p.kvrstar = 0 -- Times you've hit players w/ Invincibility
		p.kvrsnipes = 0 -- Times you've landed the Banana Snipe
		p.kvrfast = 0 -- Tics under sneaker effects (item, boost pad)
		p.kvrintinit = true
		//print("Vars set")
	end
end

local function K_Wallflower(p)
	if not p.mo or not p.mo.valid return end
	local mo = p.mo
	
	if mo.eflags & MFE_JUSTBOUNCEDWALL
		p.kvrwall = $ + 1
	end
end

addHook("MapLoad",function()
	server.kvrintermissionthinked = false
	server.kvrfinishstate = false
	server.kvrfinishtimer = kvr_inttime.value*TICRATE
	hud.enable("gametypeinfo")
	hud.enable("minimap")
	hud.enable("item")
	hud.enable("position")
	hud.enable("check")
	hud.enable("minirankings")
	hud.enable("speedometer")
	if hpmod and not hpmod_showbar then
		hpmod_showbar = true
	end
	if minrankplus and not minrankplus.enabled then
		minrankplus.enabled = true
	end
	if not kvr_intermission.value then return end
	//variable setup for basic awards
	for p in players.iterate
		if p and p.valid then
			p.kvrintinit = false
			KVR_interinit(p)
		end
	end
	awards = {}
end)

addHook("ThinkFrame", function()
	if not kvr_intermission.value then return end
	if leveltime < 1 then return end
	if (HOSTMOD and CV_FindVar("hm_intermission")) then
		COM_BufInsertText(server, "hm_intermission off")
	end
	if CV_FindVar("inttime").value
		COM_BufInsertText(server, "inttime 0")
	end

	KVR_tryTriggerResults()
	KVR_handleFinish()
	for p in players.iterate		
		if not p.kvrintinit then
			KVR_interinit(p)
		end
		K_Wallflower(p)
		
		if p.kartstuff[k_sneakertimer]
			p.kvrfast = $+1
		end
	end
	//debug shit
	if false then
		local plyr = nil
		for p in players.iterate
			if p and p.valid then
				plyr = p
				break
			end
		end
		if leveltime == 4*TICRATE then //debug shit
			KVR_AddAward("Cinematic Experience","Spent\135 32%\128 of the race spun-out, crushed, falling, or respawning.",plyr,100)
			KVR_AddAward("The fresh prince","Now this is a story all about how my life got flipped turned upside down so I'd like to take a minute just sit right there i'll tell you all about how I became the prince of Bel-Air",plyr,999)
			KVR_AddAward("You're Gonna Go Far, Kid","Travelled a total distance of \1351269\128 frac units while spun out.",plyr,120)
		end
	end
	//end horrid debug shit
	if leveltime >= 235 and not server.kvrfinishstate then
		for p in players.iterate if p and p.valid and not p.spectator then
			if p.kvrspinlastx == nil then p.kvrspinlastx = 0 end
			if p.kvrspinlasty == nil then p.kvrspinlasty = 0 end
			if p.kvrspinlastz == nil then p.kvrspinlastz = 0 end
			if p.kartstuff[k_position] <= 1 and not p.exiting then p.kvrfrontruntime = $+1 end
			if p.kartstuff[k_offroad] > 0 then p.kvroffroadtime = $+1 end
			//if p.kartstuff[k_position] == 1 and p.kartstuff[k_spinouttimer] and p.exiting then //bumped across the finish line in first place
				//HM_AddAward("HAND OF GOD","Despite being spun out, managed to finish in first place anyways.",p,500) //weighty award
			//end
			if (not P_IsObjectOnGround(p.mo) and not p.kartstuff[k_pogospring]) or p.kartstuff[k_squishedtimer] or p.kartstuff[k_spinouttimer] then
				if not p.kvrnocontroltime then
					p.kvrnocontroltime = 1
				end
				p.kvrnocontroltime = $+1
			end

			if not P_IsObjectOnGround(p.mo)
				p.kvrairtime = $+1
			end
			//print("last position x: "..p.hmspinlastx.." y: "..p.hmspinlasty.." z: "..p.hmspinlastz)
			if p.kartstuff[k_spinouttimer] > 0 then
				//print("found spinout timer for "..p.name)
				if (p.kvrspinlastx == 0 and p.kvrspinlasty == 0 and p.kvrspinlastz == 0) then
					//print("spin out pos empty")
					p.kvrspinlastx = p.mo.x
					p.kvrspinlasty = p.mo.y
					p.kvrspinlastz = p.mo.z
					//print("new position is x: "..p.mo.x.." y: "..p.mo.y.." z: "..p.mo.z)
				else
					//print("last position x: "..p.hmspinlastx.." y: "..p.hmspinlasty.." z: "..p.hmspinlastz)
					//print("new position is x: "..p.mo.x.." y: "..p.mo.y.." z: "..p.mo.z)
					local dist = P_AproxDistance(P_AproxDistance(p.mo.x - p.kvrspinlastx, p.mo.y - p.kvrspinlasty),p.mo.z - p.kvrspinlastz)/FRACUNIT
					p.kvrspinoutdist = $+dist
					//print("approx distance is: "..dist.." new total is "..p.hmspinoutdist.." fracs")
					p.kvrspinlastx = p.mo.x
					p.kvrspinlasty = p.mo.y
					p.kvrspinlastz = p.mo.z
				end
			else
				p.kvrspinlastx = 0
				p.kvrspinlasty = 0
				p.kvrspinlastz = 0
			end
		end end	
	end
	if KVR_intermissioncalc() then
		if hpmod_showbar then hpmod_showbar = false end //thank you callmore
		if minrankplus and minrankplus.enabled then minrankplus.enabled = false end //also thank you callmore
		//todo: this is atrocious and bloaty, find motivation to iterate it
		//print("thinkframe finish state detected, doing end-round award determiniation")
		local snipers = {}
		local speeddemons = {}
		local speedsters = {}
		local frontrunners = {}
		local offroaders = {}
		local nocontrollers = {}
		local spinouts = {}
		local bananaslammas = {}
		local spinnas = {}
		local orbithits = {}
		local steelers = {}
		local milehighclub = {}
		local racers = {}
		local demohits = {}
		local squishers = {}
		local starpower = {}
		local wallflowers = {}
		local warmongers = {}
		//print("building tables")
		for p in players.iterate if p and p.valid then
			//print("adding "..p.name.."to all tables")
			if p.kvrsnipes ~= nil then table.insert(snipers, p) end
			if p.kvrfast ~= nil then table.insert(speeddemons, p) end
			if p.kvrboom ~= nil then table.insert(demohits, p) end
			if p.kvrbig ~= nil then table.insert(squishers, p) end
			if p.kvrstar ~= nil then table.insert(starpower, p) end
			if p.kvrwall ~= nil then table.insert(wallflowers, p) end
			if p.kvrwar ~= nil then table.insert(warmongers, p) end
			if (p.exiting or (p.pflags & PF_TIMEOVER)) then table.insert(racers, p) end
			if p.kvrorbinauthits ~= nil then table.insert(steelers, p) end
			if p.kvrairtime ~= nil then table.insert(milehighclub, p) end
			if p.kvrbestlap ~= nil then table.insert(speedsters, p) end
			if p.kvrfrontruntime ~= nil then table.insert(frontrunners, p) end
			if p.kvroffroadtime ~= nil then table.insert(offroaders, p) end
			if p.kvrnocontroltime ~= nil then table.insert(nocontrollers, p) end
			if p.kvrspinoutdist ~= nil then table.insert(spinouts, p) end
			if p.kvrbananahits ~= nil then table.insert(bananaslammas, p) end
			if p.kvrtspinouts ~= nil then table.insert(spinnas, p) end
			if p.kvrorbithits ~= nil then table.insert(orbithits, p) end
		end end
		//print("sorting all tables")
		table.sort(snipers, function(a, b)
			return a.kvrsnipes > b.kvrsnipes
		end)
		table.sort(speeddemons, function(a, b)
			return a.kvrfast > b.kvrfast
		end)
		table.sort(steelers, function(a, b)
			return a.kvrorbinauthits > b.kvrorbinauthits
		end)
		table.sort(milehighclub, function(a, b)
			return a.kvrairtime > b.kvrairtime
		end)
		table.sort(racers, function(a, b)
			return a.realtime < b.realtime
		end)
		table.sort(speedsters, function(a, b)
			return a.kvrbestlap < b.kvrbestlap
		end)
		table.sort(frontrunners, function(a, b)
			return a.kvrfrontruntime > b.kvrfrontruntime
		end)
		table.sort(offroaders, function(a,b)
			return a.kvroffroadtime > b.kvroffroadtime
		end)
		table.sort(nocontrollers, function(a,b)
			return a.kvrnocontroltime > b.kvrnocontroltime
		end)
		table.sort(spinouts, function(a,b)
			return a.kvrspinoutdist > b.kvrspinoutdist
		end)
		table.sort(bananaslammas, function(a,b)
			return a.kvrbananahits > b.kvrbananahits
		end)
		table.sort(spinnas, function(a,b)
			return a.kvrtspinouts > b.kvrtspinouts
		end)
		table.sort(orbithits, function(a,b)
			return a.kvrorbithits > b.kvrorbithits
		end)
		table.sort(demohits, function(a, b)
			return a.kvrboom > b.kvrboom
		end)
		table.sort(squishers, function(a, b)
			return a.kvrbig > b.kvrbig
		end)
		table.sort(starpower, function(a, b)
			return a.kvrstar > b.kvrstar
		end)
		table.sort(wallflowers, function(a, b)
			return a.kvrwall > b.kvrwall
		end)
		table.sort(warmongers, function(a, b)
			return a.kvrwar > b.kvrwar
		end)
		
		-- Speed Awards
		if #racers > 1 then
			local randtitle = "CLOSE SHAVE"
			if racers[2].realtime - racers[1].realtime == 1
				if racers[2].kvrfrontruntime > 80*TICRATE
					local scolor = racers[2].skincolor
					randtitle = "\133HIGHWAY ROBBERY"
					KVR_AddAward(randtitle, "Stole 1st place from "..kvr_color[scolor]..racers[2].name.." \128at the last possible moment. Too bad!", racers[1], 200)
				else
					randtitle = "\133PHOTO FINISH"
					KVR_AddAward(randtitle, "Beat 2nd place by a single tic. What a close race!", racers[1], 200)
				end
			elseif (racers[1].realtime == racers[2].realtime and not (racers[1].pflags & PF_TIMEOVER or racers[2].pflags & PF_TIMEOVER)) then
				randtitle = "SHARED VICTORY"
				local scolor = racers[2].skincolor
				KVR_AddAward(randtitle, "Tied with "..kvr_color[scolor]..racers[2].name.." \128for 1st place. Excellent!", racers[1], 300)
			end

			if frontrunners[1].kvrfrontruntime > 60*TICRATE then
				local time = frontrunners[1].kvrfrontruntime/TICRATE
				local randtitle = "\138FRONTRUNNER"
				if leveltime%2 then
					randtitle = "\138PACK LEADER"
				end
				if frontrunners[1].kvrfrontruntime > 90*TICRATE and frontrunners[1].kartstuff[k_position] ~= 1 then
					if leveltime%4 == 0 then
						randtitle = "\133QUICK, CALL 9-1-1!"
					elseif leveltime%4 == 1 then
						randtitle = "\133CHOKING HAZARD"
					elseif leveltime%4 == 2 then
						randtitle = "\133CHOKE ARTIST"
					elseif leveltime%4 == 3 then
						randtitle = "\133CALL AN AMBULANCE"
					end
					KVR_AddAward(randtitle,"Despite spending \138"..time.." seconds \128leading in total, managed to somehow choke and lose first place.",frontrunners[1],50+time)
				else
					KVR_AddAward(randtitle,"Maintained 1st for \130"..time.." seconds	\128in total this race.",frontrunners[1],15+time)
				end
			end
		end
	
		if speedsters[1].kvrbestlap > 1 then
			local lap = buildTimeString(speedsters[1].kvrbestlap)
			local time = speedsters[1].kvrbestlap/TICRATE
			local randtitle = "SPEEDSTER"
			if leveltime%3 == 2 then
				randtitle = "\136SPEEDY GONZALEZ"
			elseif leveltime%3 == 1 then
				randtitle = "\136MADE IN HEAVEN" -- I cannot be stopped.
			elseif leveltime%3 == 0
				randtitle = "\136THE FLASH"
			end
			KVR_AddAward(randtitle, "Best Lap: \136"..lap, speedsters[1], 5*(time/2))
		end
		if speeddemons[1].kvrfast >= 30*TICRATE
			local time = speeddemons[1].kvrfast/TICRATE
			local randtitle = "\133NEED FOR SPEED"
			if leveltime%2 then randtitle = "\133G-FORCE ENTHUSIAST" end
			KVR_AddAward(randtitle, "Spent \133"..time.." seconds \128under sneaker effects. Gotta go fast!", speeddemons[1], 50+time)
		end
		if milehighclub[1].kvrairtime > 20*TICRATE then
			local time = milehighclub[1].kvrairtime/TICRATE
			local randtitle = "\132FREQUENT FLYER"
			if leveltime%2 then randtitle = "\132FALLING WITH STYLE" end
			KVR_AddAward(randtitle,"Spent \132"..time.." seconds \128in the air.", milehighclub[1], time*5)
		end
		
		--Item Play Awards
		if warmongers[1].kvrwar >= 20
			local randtitle = "\133WARMONGER"
			if leveltime%2 then randtitle = "\133BATTLE TENDENCY" end -- Yep.
			KVR_AddAward(randtitle,"Scored \133"..warmongers[1].kvrwar.." hits \128overall with items.",warmongers[1],5*warmongers[1].kvrwar)
		end
		if steelers[1].kvrorbinauthits > 3 then
			local randtitle = "BALLS"
			if steelers[1].kvrorbinauthits >= 7 then
				randtitle = "\140STEEL BALL RUN" -- Before you ask, yes it is.
				KVR_AddAward(randtitle, "Landed \140"..steelers[1].kvrorbinauthits.." hits \128with Orbinauts. It's all in the Spin.", steelers[1], steelers[1].kvrorbinauthits*20) -- I regret nothing.
			else
				randtitle = "\140BALLS OF STEEL"
				KVR_AddAward(randtitle, "Landed \140"..steelers[1].kvrorbinauthits.." \128hits with Orbinauts. Hail to the King, baby.", steelers[1], steelers[1].kvrorbinauthits*15)
			end
		end  
		if snipers[1].kvrsnipes >= 3 then
			local snipes = snipers[1].kvrsnipes
			local randtitle = "\130MEET THE SNIPER"
			if leveltime%2 then
				randtitle = "\130SPECIAL K"
			end
			KVR_AddAward(randtitle, "Landed \130"..snipes.." snipes \128with bananas - just honest work.", snipers[1], 60*snipes)
		end
		
		if demohits[1].kvrboom >= 5 then
			local randtitle = "\133DEMOLITIONS EXPERT"
			if leveltime%2 then
				randtitle = "\133KILLER QUEEN"
			end
			KVR_AddAward(randtitle,"Scored \133"..demohits[1].kvrboom.." hits \128with explosives.",demohits[1],15*demohits[1].kvrboom)
		end
		if squishers[1].kvrbig >= 5 then
			local randtitle = "HUGE QUEST"
			if leveltime%2 then 
				randtitle = "\132WELCOME TO IHOP"
			else 
				randtitle = "\132WELCOME TO DENNY'S"
			end
			KVR_AddAward(randtitle,"Flattened players \132"..squishers[1].kvrbig.." times\128. What a rampage!",squishers[1],15*squishers[1].kvrbig)
		end
	
		if starpower[1].kvrstar >= 5
			local randtitle = "SUPERSTAR"
			if leveltime%2 then randtitle = "\130STARDUST CRUSADER" end -- I'm not sorry.
			KVR_AddAward(randtitle,"Rammed players \130"..starpower[1].kvrstar.." times \128while invincible.",starpower[1],15*starpower[1].kvrstar)
		end
		
		-- Blooper Reel
		if kvr_bloopers.value
			if wallflowers[1].kvrwall >= 50
				KVR_AddAward("\139GBJ", "Bumped into walls \139"..wallflowers[1].kvrwall.." times\128. Heads up: The respawn command exists.",wallflowers[1],6*wallflowers[1].kvrwall)
			elseif wallflowers[1].kvrwall >= 15
				KVR_AddAward("\139JESUS TAKE THE WHEEL", "Bumped into walls \139"..wallflowers[1].kvrwall.." times\128. Don't text and drive.",wallflowers[1],6*wallflowers[1].kvrwall)
			end
			if offroaders[1].kvroffroadtime > 10*TICRATE then
				local x = offroaders[1].kvroffroadtime
				local timestring = x/TICRATE
				local randtitle = "\131DIRTY DAN"
				if leveltime%4 == 3 then 
					randtitle = "\131JOE DIRT"
				elseif leveltime%4 == 2
					randtitle = "\131FEARLESS LAWNMOWER"
				elseif leveltime%4 == 1
					randtitle = "\131CONSIDERS ASPHALT OPTIONAL"
				end
				KVR_AddAward(randtitle,"Spent a total of \131"..timestring.." seconds\128 in offroad this race.",offroaders[1],5+((x/TICRATE)*2))
			end
			if nocontrollers[1].kvrnocontroltime > 20*TICRATE then
				local x = nocontrollers[1].kvrnocontroltime
				local timestring = x/TICRATE
				KVR_AddAward("\133CINEMATIC EXPERIENCE","Spent\133 "..timestring.." seconds \128falling, spun out, crushed, or otherwise out of control of their kart.",nocontrollers[1],20+(x/TICRATE/2))
			end
			if spinouts[1].kvrspinoutdist >= 12500 then
				local randtitle = "BEYBLADE"
				if leveltime%4 == 0 then 
					randtitle = "SPEEEEEEEN"
				elseif leveltime%4 == 1 then
					randtitle = "LET IT RIP"
				elseif leveltime%4 == 2 then
					randtitle = "YOU'RE GONNA GO FAR, KID"
				elseif leveltime%4 == 3 then
					randtitle = "BEYBLADEEEEE"
				end
				KVR_AddAward("\142"..randtitle,"Travelled a total distance of \135"..spinouts[1].kvrspinoutdist.." frac units\128 while spinning out.",spinouts[1],spinouts[1].kvrspinoutdist/100)
			end
			if bananaslammas[1].kvrbananahits >= 3 then
				KVR_AddAward("\130BANANA SLAMMA","Spun out by \130"..bananaslammas[1].kvrbananahits.." bananas \128on the track this race. Too much potassium can be bad for you.",bananaslammas[1],bananaslammas[1].kvrbananahits*5)
			end
			if spinnas[1].kvrtspinouts >= 5 then
				local randtitle = "ACCIDENT PRONE"
				if leveltime % 2 then randtitle = "ACCIDENT PRONE" else randtitle = "HIGH INSURANCE PAYMENTS" end
				KVR_AddAward("\135"..randtitle,"Spun out by hazards \135"..spinnas[1].kvrtspinouts.." times.\128",spinnas[1],5*spinnas[1].kvrtspinouts)
			end
			if orbithits[1].kvrorbithits >= 2 then
				KVR_AddAward("\135INVADES PERSONAL SPACE","Collided with Jawz and Orbinauts held out by players \135"..orbithits[1].kvrorbithits.." times.\128",orbithits[1],15*orbithits[1].kvrorbithits)
			end
		end
		local tplayers = 0
		local allplayers = {}
		for p in players.iterate if p and p.valid then
			tplayers = $+1
			table.insert(allplayers, p)
		end end
		if leveltime%3 == 0 then
			if leveltime%2 then
				KVR_AddAward("\130PARTICIPATION TROPHY","Thanks for playing!",allplayers[leveltime%tplayers],5)
			else
				KVR_AddAward("\129I'VE GAY","has gay lmao",allplayers[leveltime%tplayers],5)
			end
		end
		chosenawards = chooseawards(awards, 5)
		
		local rankings = {}
		local tplayers = 0
		for p in players.iterate
			if (p and p.valid) and not p.spectator and not (p.pflags&PF_TIMEOVER)
				table.insert(rankings, p)
				tplayers = $+1
			end
		end
		table.sort(rankings, function(a, b) return a.realtime < b.realtime end)
		for i=1, #rankings //assigns where they ranked so I can properly maybe assign points
			rankings[i].kvrfinishpoints = tplayers-i
		end
	end
end)

local function KVR_ItemPlay(p, inf, source)
	if not kvr_intermission.value then return end
	p.kvrtspinouts = $+1
	if p and p.valid and inf and inf.valid then
		if inf.type == MT_BANANA or inf.type == MT_BANANA_SHIELD then p.kvrbananahits = $+1 end
		if inf.type == MT_JAWZ_SHIELD or inf.type == MT_ORBINAUT_SHIELD or inf.type == MT_BANANA_SHIELD then p.kvrorbithits = $+1 end
	end
	
	if inf and inf.valid then
		if source and source.player then
			local s = source.player
			if (s == p)
				s.kvrwar = $ + 0
			else
				s.kvrwar = $ + 1
			end
		
			if ((inf.type == MT_SSMINE) or (inf.type == MT_SSMINE_SHIELD) or (inf.type == MT_MINEEXPLOSION) or (inf.type == MT_SPBEXPLOSION) or (inf.type == MT_SPBEXPLOSION and inf.extravalue1)) then
				if (s == p)
					s.kvrboom = $ + 0
				else
					s.kvrboom = $ + 1
				end
			end
			if s.kartstuff[k_invincibilitytimer] then
				s.kvrstar = $ + 1
			end
			if inf.type == MT_ORBINAUT or inf.type == MT_ORBINAUT_SHIELD then
				if s == p
					s.kvrorbinauthits = $ + 0
				else
					s.kvrorbinauthits = $+1
					--CONS_Printf(s, "Blow it out your ass.")
				end
			end
			if not (inf.type == MT_BANANA_SHIELD) and (inf.type == MT_BANANA)
			and inf.health > 1 -- According to Hitfeed, this is how banana snipes happen. What the fuck
				if s == p
					s.kvrsnipes = $+0
				else
					s.kvrsnipes = $+1
				end
			end
		end
	end
end

addHook("PlayerSpin", KVR_ItemPlay)
addHook("PlayerExplode", KVR_ItemPlay)
addHook("PlayerSquish", function(p, inflictor, source)
	if not kvr_intermission.value then return end
	if not (source and source.player) then return end
	if not (p.mo and p.mo.valid) then return end
	local s = source.player
	if (inflictor.player)
		if ((s.kartstuff[k_growshrinktimer] > 0) or (HugeQuest and s.huge > 0))
			if (s == p)
				s = nil 
			else
				s.kvrbig = $+1
			end
		end
	end
end)
local wrapped = {}

-- I KNOW THERE'S A FUCKIN FUNCTION IN SOURCE FOR THIS
-- WHY IS IT NOT EXPOSED TO LUA
-- LAAAAAAAAAAAAAAAAAAAAAAT
local function wrapString(str, width, v, flags, font)
	local words = {}
	for word in str:gmatch("%S+") do table.insert(words, word) end
	local retlines = {}
	local buffer = words[1]
	for i = 2, #words
		local fug = buffer.." "..words[i]
		if v.stringWidth(fug, flags, font) > width then
			table.insert(retlines, buffer)
			buffer = words[i]
		else
			buffer = fug
		end
	end
	table.insert(retlines, buffer)
	return retlines
end

local function doEscapeCode(str)
	for _, v in pairs(kvr_escape)
		str = str:gsub(v.a, v.b)
	end
	return str
end

-- hacked-up TSR scoreboard, WHEEEEEEEEEEEEEEE
-- thanks snu
hud.add(function(v, p, c)
	if not kvr_intermission.value then return end
	if KVR_intermissioncalc() then
		hud.disable("gametypeinfo")
		hud.disable("minimap")
		hud.disable("item")
		hud.disable("position")
		hud.disable("check")
		hud.disable("minirankings")
		hud.disable("speedometer")
	end
	if not server.kvrfinishstate then return end
	v.fadeScreen(0xFF00, 16)	-- fade the screen

	-- store highlight colour here for use in the hud throughout
	local hilicol
	if (CV_FindVar("menuhighlight").value)
		hilicol = CV_FindVar("menuhighlight").value
	elseif (modeattacking)
		hilicol = V_ORANGEMAP
	else
		hilicol = ((gametype == GT_RACE) and V_SKYMAP or V_REDMAP)
	end
	-- draw lap count and game speed
	//if not G_BattleGametype() then
		//v.drawString(64, 8, "LAP COUNT", 0, "center")
		//v.drawString(64, 16, (numlaps), hilicol, "center")
		//v.drawString(256, 8, "GAME SPEED", 0, "center")
		//v.drawString(256, 16, CV_FindVar("kartspeed").string, hilicol, "center")
	//end
	
	v.drawString(160, 16, "** RESULTS **", 0, "center")
	
	if server.kvrfinishtimer then
		v.drawString(160,190,"NEXT MATCH IN "..string.format("%02i",server.kvrfinishtimer/TICRATE), V_SNAPTOBOTTOM|hilicol,"center")
	end
	-- draw line between gametypeinfo and teams
	local dupadjust = (v.width()/v.dupx())
	local duptweak = (dupadjust - 320)/2	-- BASEDVIDWIDTH = 320 (based on what?)
	v.drawFill(1-duptweak, 26, dupadjust-2, 1, 0)	-- horizontal
	v.drawFill(160, 26, 1, 162, 0)	-- vertical
	
	//v.drawString(4, 188, hm_trim(mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl).." - "..mapheaderinfo[gamemap].subttl, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")
	v.drawString(4, 188, kvr_trim(mapheaderinfo[gamemap].lvlttl.." "..mapheaderinfo[gamemap].zonttl), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_ALLOWLOWERCASE, "thin")

	local restat = CV_FindVar("hm_restat")
	
	local hy = 28 //vertical offset
	local hx = 0 //horizontal offset
	local beeg = false
	local lastrank = 0 //last rank we drew (ties)
	local hyanim = 0 //this is so disorganized at this point, this is for sliding the ranks up or down so scores can display next
	local drawingscores = false
	
	
	//im not sure what math I did to get this to work so im just never going to touch it again:
	local halfwaypt = (CV_FindVar("kvr_inttime").value*TICRATE)/2
	if server.kvrfinishtimer <= halfwaypt then
		if server.kvrfinishtimer >= halfwaypt-(3*TICRATE/2) then
			hyanim = max(-1*(-210+(6*(server.kvrfinishtimer-(halfwaypt-TICRATE)))),-210)
			//print("timer: "..server.hmfinishtimer.." hyanim: "..hyanim)
		elseif server.kvrfinishtimer >= halfwaypt-(2*TICRATE+1) then
			hyanim = 1*(6+(6*(server.kvrfinishtimer-(halfwaypt-(TICRATE*2)))))
			//print("TAKE IT BACK NOW timer: "..server.hmfinishtimer.." hyanim: "..hyanim)
		end //the above abomination smoothly slides ranks out of the way in 1 second and lingers for 0.5 seconds
	end
	
	if server.kvrfinishtimer <= halfwaypt-TICRATE then
		drawingscores = true
	end
	
	-- draw players
	local rankings = {}
	local tplayers = 0
	for p in players.iterate
		if (p and p.valid) and not p.spectator and not (p.pflags&PF_TIMEOVER)
			table.insert(rankings, p)
			tplayers = $+1
		end
	end
	if server.kvrfinishstate then
		table.sort(rankings, function(a, b) return a.realtime < b.realtime end)
	elseif not drawingscores then
		table.sort(rankings, function(a, b) return a.kartstuff[k_position] < b.kartstuff[k_position] end)
	end
	for p in players.iterate
		if not p.spectator and (p.pflags&PF_TIMEOVER) then
			table.insert(rankings, p)
			tplayers = $+1
		end
	end
	for p in players.iterate
		if p.spectator
			table.insert(rankings, p)
		end
	end
	if drawingscores then
		table.sort(rankings, function(a, b) return a.kvrscore > b.kvrscore end)
	end
	if not #rankings then return end
	
	for i = 1, #rankings
		local p = rankings[i]
		if i~=1 then hy = $+10 end
		if beeg then //flag for bigger panes so the panes below it draw proper
			hy=$+4
		end
		beeg = false
		local specflag = (p.spectator or p.rs_check2) and V_50TRANS or 0
		-- player ping:
		if (p ~= server)  -- the server doesnt have a ping
		and (netgame)	-- we obviously need to be in a netgame too
			-- my hopes with writing this code is that it's so bad that I'm never allowed to write ping related code ever again
			local ping = p.ping	-- thanks 1.3
			-- get the ping patch we'll use
			local ping_gfxnum, ping_values = 1, {76, 137, 256, 500}
			for i = 1, #ping_values
				if (ping >= ping_values[i]) then ping_gfxnum = i+1 end
			end
			-- sadly p.cmd.latency caps at 11 so it cant go any higher without hacks so huge that I cant be assed
			v.draw(3, hy+hyanim, v.cachePatch("KVRPING"..ping_gfxnum), specflag)
		end
		-- rank:
		if not p.spectator then
			if drawingscores then
				v.drawString(29, hy+1+hyanim, i, 0, "right")
			else
				if i > 1 and p.realtime == rankings[i-1].realtime then
					v.drawString(29, hy+1+hyanim, lastrank, 0, "right")
				else //above handles ties so they show up proper placement-wise
					lastrank = i
					v.drawString(29, hy+1+hyanim, i, 0, "right")
				end
			end
		end
		-- draw skin icon
		if (p.mo and p.mo.valid) then
			local pp = skins[p.mo.skin].facerank
			local ppscale = FRACUNIT/2 //8 pixels
			if i <= 3 or (p.realtime == rankings[i-1].realtime and lastrank <= 3) then
				pp = skins[p.mo.skin].facewant
				ppscale = 3*FRACUNIT/8 //12 pixels
				hx = 4 //adjust 4 right
				beeg = true
			end
			local cmap = v.getColormap(p.mo.skin, p.mo.color)
			local dieflag = 0
			if p.mo.colorized then cmap = v.getColormap(TC_RAINBOW, p.mo.color) end
			if G_BattleGametype() and p.kartstuff[k_bumper] <= 0 then
				cmap = v.getColormap(TC_RAINBOW, SKINCOLOR_GREY)
				dieflag = V_50TRANS
			end
			v.drawScaled(30<<FRACBITS, (hy+hyanim+1)<<FRACBITS, ppscale, v.cachePatch(pp), specflag|dieflag, cmap)
		end
		//draw name
		local fugname = ""
		if p.HMclan then fugname = $.."\140"..p.HMclan.." \128" end
		--if p.HMclan then fugname = $..hm_color[p.skincolor]..p.HMclan.." | \128" end
		if p == consoleplayer and p.skincolor then fugname = $..(kvr_color[p.skincolor] or "\x80") end
		if p.name == nil then
			fugname = $.."Glitched player :?"
		else
			fugname = $..p.name
		end
		while v.stringWidth(fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin") > 100
			fugname = $:sub(1, -2)
		end
		//speed/weight restat
		v.drawString(39+hx, hy+hyanim, fugname, V_6WIDTHSPACE|V_ALLOWLOWERCASE|specflag, "thin")
		if (p.mo and p.mo.valid) then
			if (HOSTMOD) then
				if restat.value then
					if p.HMRs then
						if i <= 3 or (p.realtime == rankings[i-1].realtime and lastrank <= 3) then
							v.drawString(29, hy+hyanim, p.HMRs, 0, "small")
							v.drawString(39+hx, hy+hx+6+hyanim, p.HMRw, 0, "small-right")
						else
							v.drawString(29, hy+hyanim, p.HMRs, 0, "small")
							v.drawString(39+hx-4, hy+hx+6+hyanim-4, p.HMRw, 0, "small-right")
						//god I dont even care anymore this is such a fucking mess
						end
					end
				end
			end
		end
		-- points:
		local points = ""
		if not drawingscores then
			if p.spectator then
				if p.pflags & PF_WANTSTOJOIN then
					points = "WAIT"
				else
					points = "SPEC"
				end
			elseif p.rs_check2 then
				points = "RAGE"
			elseif p.pflags & PF_TIMEOVER then
				points = "NO CONTEST."
			elseif G_BattleGametype() then
				points = p.marescore
			elseif not p.exiting then
				points = "LAP "..(p.laps+1)
			else
				points = buildTimeString(p.realtime)
			end
		else 
			//FUN FACT EVERYTHING FOR SCORE IS HANDLED DURING INTERMISSION
			//SO I LITERALLY JUST HAVE TO PRETEND INTERMISSION CALCULATED
			//NO THIS DOESN'T TAKE INTO ACCOUNT TIES FUCK YOU
			if p.kvroldscore and p.kvroldscore < p.kvrscore then
				points = "(+"..p.kvrscore-p.kvroldscore..") "..p.kvrscore
			elseif p.kvroldscore and p.kvroldscore > p.kvrscore then
				points = "("..p.kvrscore-p.kvroldscore..") "..p.kvrscore
			else
				points = p.kvrscore
			end
		end
		v.drawString(157, hy+hyanim, points, (p.exiting and hilicol or 0)|V_6WIDTHSPACE|specflag, "thin-right")
	end
	--RIGHT PANE DRAWING
	local fx = 163
	v.drawString(240,28,"* HIGHLIGHTS *",0,"center")
	//table.sort(chosenawards, function(a,b)
		//return a.weight > b.weight
	//end)
	for i, k in pairs(chosenawards)
		//print("Checking for player...")
		if chosenawards[i].pl and chosenawards[i].pl.valid then
			continue
		else
			table.remove(chosenawards, i)
			//print("Removed a now non-existent player from chosenawards")
		end
	end
	local fy = 40
	local startfy = 40
	for i, pl in pairs(chosenawards)
		//print("new fy: "..fy)
		startfy = fy
		if fy > 175 then return end //dont draw off the screen lmao
		if not chosenawards[i].title then
			continue
		end
		//icon
		local plyr = chosenawards[i].pl
		if not (plyr and plyr.valid) then continue end
		if plyr.mo and plyr.mo.valid then
			local pp = skins[plyr.mo.skin].facewant
			local cmap = v.getColormap(plyr.mo.skin, plyr.mo.color) //4*FRACUNIT/5
			v.drawScaled(163<<FRACBITS, (fy+1)<<FRACBITS, (3*FRACUNIT)/4, v.cachePatch(pp), 0, cmap)
		end
		//title //fx+30
		v.drawString(fx+26,fy, chosenawards[i].title, 0, "small")
		fy=$+5
		//recipient
		local tcol = "\x80"
		if chosenawards[i].pl.skincolor then
			tcol = kvr_color[p.skincolor] or "\x80" //default to white if no color found
		end //fx+30
		v.drawString(fx+26,fy, tcol..chosenawards[i].pl.name, V_ALLOWLOWERCASE, "small")
		fy=$+7
		//description
		local wrapstr = wrapString(chosenawards[i].desc, 120, v, V_ALLOWLOWERCASE, "small")
		for i, val in ipairs(wrapstr)
			v.drawString(fx+26,fy, val, V_ALLOWLOWERCASE, "small")
			fy=$+5
		end
		fy=$+2
		if fy-26 < startfy then fy = startfy+26 end //needs min 26 px spacing for the icon
	end
end,"game")

//so other scripts can tell when its time to calculate their awards, if not done in-game
rawset(_G, "KVR_intermissioncalc", function()
	return server.kvrfinishstate and server.kvrfinishtimer == (CV_FindVar("kvr_inttime").value*TICRATE)-1
end)