freeslot(
	"MT_RIVALSIGN",
	"S_RIVALSIGN",
	"SPR_RIVL"
)

------------Rival Indicator, draw code ported from TSR mode by Snu-------------
mobjinfo[MT_RIVALSIGN] = {
	spawnstate = S_RIVALSIGN,
	radius = 36*FRACUNIT,
	height = 37*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY|MF_DONTENCOREMAP,
	dispoffset = -2
}

states[S_RIVALSIGN] = {
	sprite = SPR_RIVL,
	frame = FF_TRANS30|FF_ANIMATE|A,
	var1 = 1,
	var2 = 7
}

rawset(_G, "kvr_isrival", function(p1, p2)
	if not (p1 and p1.valid) then return end
	if not (p2 and p2.valid) then return end
	if (leveltime < 236) then return end
	
	if KVR_ingame() > 1
		if p1.kvrpendingrival-1 == #p2 and p2.kvrpendingrival-1 == #p1
			return true
		end
	end
	return false
end)

rawset(_G, "kvr_signmaker", function(p)
	local mo = p.mo
	if not (mo.rivalsign and mo.rivalsign.valid)
		mo.rivalsign = P_SpawnMobj(mo.x, mo.y, mo.z, MT_RIVALSIGN)
		mo.rivalsign.target = mo
		mo.rivalsign.colorized = true
		mo.rivalsign.color = mo.rivalsign.target.player.skincolor
		mo.rivalsign.flags2 = MF2_DONTDRAW
	end
end)
addHook("MobjThinker", function(rvl)
	if (rvl and rvl.valid)
		-- now for remove situations
		if not ((rvl.target and rvl.target.valid) and rvl.target.player) then P_RemoveMobj(rvl) return end -- they dont have a target, or it's not a player
		if not (rvl.target.player.health) then P_RemoveMobj(rvl) return end -- target is dead

		local s = rvl.target.scale*11/10 -- base scale

		-- don't draw if the target isnt drawn
		if (rvl.target.flags2 & MF2_DONTDRAW)
			rvl.flags2 = $|MF2_DONTDRAW
		else
			rvl.flags2 = $ & ~MF2_DONTDRAW
		end

		-- set scale
		if not (splitscreen)
			if ((displayplayers[0] and displayplayers[0].valid) and (displayplayers[0].mo and displayplayers[0].mo.valid))
				s = rvl.target.scale + FixedMul(FixedDiv(abs(P_AproxDistance(displayplayers[0].mo.x - rvl.target.x, displayplayers[0].mo.y - rvl.target.y)), 1280<<FRACBITS), rvl.target.scale)
				if (s > 6*rvl.target.scale)
					s = 6*rvl.target.scale
				end
			end
		end
		rvl.destscale = s

		-- hide if this guy ain't our rival (with splitscreen support, BLESS 1.2)
		local drawFlags = {MFE_DRAWONLYFORP1, MFE_DRAWONLYFORP2, MFE_DRAWONLYFORP3, MFE_DRAWONLYFORP4}
		for i = 0, (splitscreen) -- go through displayplayers
			if not (displayplayers[i]) then break end
			if (rvl.target.player == displayplayers[i]) then rvl.eflags = $ & ~(drawFlags[i+1]) continue end -- dont show yourself
					
			if (kvr_isrival(displayplayers[i], rvl.target.player))
			and not (rvl.target.player.exiting)
				rvl.eflags = $|drawFlags[i+1]
			else
				rvl.eflags = $ & ~(drawFlags[i+1])
			end
		end
		-- somehow this isnt supposed to be displayed at ALL for any displayplayers, so dont draw it
		if not (rvl.eflags & (MFE_DRAWONLYFORP1|MFE_DRAWONLYFORP2|MFE_DRAWONLYFORP3|MFE_DRAWONLYFORP4))
			rvl.flags2 = $|MF2_DONTDRAW
		end

		-- set position (flip support too)
		if (rvl.target.eflags & MFE_VERTICALFLIP)
			P_TeleportMove(rvl, rvl.target.x, rvl.target.y, rvl.target.z - P_GetPlayerHeight(rvl.target.player) - (16*rvl.target.scale) - (32*s))
			rvl.eflags = $|MFE_VERTICALFLIP
		else
			P_TeleportMove(rvl, rvl.target.x, rvl.target.y, rvl.target.z + P_GetPlayerHeight(rvl.target.player) + (16*rvl.target.scale) + (32*s))
			rvl.eflags = $ & ~MFE_VERTICALFLIP
		end
	end
end, MT_RIVALSIGN)
-------------------------------------------------------------------------------