--I've found you, faker!
--A lot of this was sourced from Combi, with extra features tacked on by me

-------------------CVAR Block--------------------
local kvr_rivalchance = CV_RegisterVar({
	name = "kvr_rivalchance",
	defaultvalue = "50",
	flags = CV_NETVAR,
	possiblevalue = {MIN = -1, MAX = 100}
})

local kvr_archrivalchance = CV_RegisterVar({
	name = "kvr_archrivalchance",
	defaultvalue = "50",
	flags = CV_NETVAR,
	possiblevalue = {MIN = -1, MAX = 100}
})

local kvr_rmusic = CV_RegisterVar({
	name = "kvr_rmusic",
	defaultvalue = "On",
	flags = 0,
	possiblevalue = CV_OnOff
})

local kvr_armusic = CV_RegisterVar({
	name = "kvr_armusic",
	defaultvalue = "On",
	flags = 0,
	possiblevalue = CV_OnOff
})
-------------------------------------------------






----------------------------------Music Block----------------------------------
local function M_RandomSong()
	local rand = kvr_rivaltable[P_RandomRange(1, #kvr_rivaltable)].name
	--print(rand)
	return rand
end

COM_AddCommand("kvr_musiclist", function (p)
	CONS_Printf(p, "---Rival Music Table---")
	for _,v in ipairs(kvr_rivaltable)
		CONS_Printf(p, "*"..v.info)
	end
	CONS_Printf(p, "---Archrival Music Table---")
	for _,v in ipairs(kvr_archrivaltable)
		CONS_Printf(p, "*"..v.info.."("..v.pair[1].."/"..v.pair[2]..")")
	end
	CONS_Printf(p, "---Character Themes---")
	for _,v in ipairs(kvr_solotable)
		CONS_Printf(p,"*"..v.pair[1].." - "..v.info)
	end
end)

--I love maps with mid-lap music changes. I hate when they override my Rival 
--music - let's fix that!
addHook("MusicChange", function(oldmusic, newmusic, flags, looping)
	--print("oldmusic:"..oldmusic.."  newmusic:"..newmusic)
	if leveltime < 240 return end
	for dp in displayplayers.iterate
		local musicstore
		if ((HugeQuest and (dp.huge and dp.huge >= 1)) or dp.kartstuff[k_growshrinktimer] >= 1)
		or dp.kartstuff[k_invincibilitytimer] >= 1 then
			return false
		end
		if (dp.exiting or (dp.pflags & PF_TIMEOVER)) then return false end
		if ((dp.hasrival) and (dp.musicset))
			if newmusic == "kinvnc" or newmusic == "kgrow"
				musicstore = oldmusic
			end
			if newmusic == "chalng"
				return "chalng", flags, false
			else
				if (newmusic ~= oldmusic) 
					return true
				end
			end
		end
	end
end)

rawset(_G, "KVR_BetTable", {1000, 500, 250, 50})
rawset(_G,"KVR_BetTier", function(p)
	for i=1, #KVR_RankTable do
		if p.hasbet and (p.kvrwager >= KVR_BetTable[i]) then
			p.kvrbettier = i
			break
		end
	end
end)


---------------------------Setting Rivals and Wagers---------------------------
local function PRINTF(p,m)
	CONS_Printf(p,m)
end

COM_AddCommand("kvr_rival", function (p, rival, in_chat)
	local printfunc = in_chat and chatprintf or PRINTF
	local color = in_chat and "\x88" or ""
	local nemesis = tonumber(rival)
	
	if not rival then
		if not in_chat then
			CONS_Printf(p, 'kvr_rival "name/node": Challenge your rival! They must accept the challenge.')
		end
		return
	end
	
	if not (p and p.valid)
		printfunc(p, "You're not in-game yet!")
		return
	end
	
	
	if G_BattleGametype()
		printfunc(p, "Rivalry settings are locked in Battle Mode.")
		return
	end

	if rival:lower() == "none"
		if p.kvrpendingrival and players[p.kvrpendingrival-1].valid then
			players[p.kvrpendingrival-1].kvrpendingrival = 0
			players[p.kvrpendingrival-1].kvrrival = "none"
			players[p.kvrpendingrival-1].kvrrivalwins = 0
			players[p.kvrpendingrival-1].kvrrivallosses = 0
			players[p.kvrpendingrival-1].kvrrivaldraws = 0
			players[p.kvrpendingrival-1].hasrival = 0
			CONS_Printf(players[p.kvrpendingrival-1], ""..p.name.." is no longer your rival.")
			--print("breakups suck.")
		end
		p.kvrpendingrival = 0
		p.kvrrival = "none"
		p.kvrrivalwins = 0
		p.kvrrivallosses = 0
		p.kvrrivaldraws = 0
		p.hasrival = 1
		printfunc(p, "You no longer have a rival.")
		return
	end
	
	if p.kvrpendingrival
		if rival:lower() == players[p.kvrpendingrival-1].name:lower()
			printfunc(p, "They're already your rival!")
			return
		elseif (nemesis ~= #players[p.kvrpendingrival-1] or rival:lower() ~= players[p.kvrpendingrival-1].name:lower() or rival:lower() ~= p.kvrrival:lower())
			printfunc(p, "You can't challenge someone new during a rivalry. Say \"challenge none\" to end your current rivalry first.")
			return
		end
	else
		if (rival:lower() ~= p.kvrrival:lower() and p.kvrrival:lower() ~= "none") then
			printfunc(p, "You can't challenge someone new during a rivalry. Say \"challenge none\" to end your current rivalry first.")
			return
		end
	end
		
	-- Sourced from sk_setscore command
	local nemesis = tonumber(rival)
	local target = nil
	local results = {}
	
	if nemesis ~= nil and nemesis >= 0
		if players[nemesis] == p
			printfunc(p, "You can't challenge yourself!")
			return
		else
			target = players[nemesis]
		end
	end
	
	if target == nil
		for p in players.iterate
			if string.find(p.name:lower(), rival:lower(),0,true)~=nil then
					table.insert(results, p)
			end
		end
		if #results > 1 then
			printfunc(p, "Found more than one player matching that name. Be more specific or use a node:")
			for i=1,#results do
				printfunc(p, results[i].name.." [Node "..#results[i].."]")
			end
			return
		elseif #results < 1 then
			printfunc(p, "No players found by that name. (In-game players only)")
			return
		else
			if results[1] == p
				printfunc(p, "You can't challenge yourself!")
				return
			else
				target = results[1]
			end
		end
	end
	
	if target and target.valid
		p.kvrpendingrival = #target+1
	end

	
	local str = target.name.." will be your rival if they accept."
	if target.kvrpendingrival and target.kvrpendingrival-1 == #p then
		str = target.name.." is now your rival!"
		players[p.kvrpendingrival-1].hasrival = true
	elseif target.kvrpendingrival and target.kvrpendingrival-1 ~= #p then
		str = target.name.." already has a rival!"
		p.kvrpendingrival = 0
		printfunc(p, color.. str, false)
		return
	end
	
	printfunc(p, color.. str, false)
	
	str = p.name.." wants to challenge you! Say \"!ch "..p.name.."\" or \"!ch "..#p.."\" to accept."
	if target.kvrpendingrival and target.kvrpendingrival-1 == #p then
		str = p.name.. " has accepted your challenge and is now your rival!"
		p.hasrival = true
	elseif target.kvrpendingrival and target.kvrpendingrival-1 ~= #p then
		str = p.name.. " already has a rival!"
	end
	
	chatprintf(target, "\x88"..str, true)
	S_StartSound(nil, sfx_rvchln, target)
end)

COM_AddCommand("kvr_wager", function(p, wager, in_chat)
	local printfunc = in_chat and chatprintf or PRINTF
	local color = in_chat and "\x88" or ""
	local bet = tonumber(wager)
	
	if not p.kvrpendingrival then -- You can't bet with thin air, genius
		printfunc(p, "You need to have a rival first!")
		return
	end

	if bet == nil then
		if not in_chat then
			CONS_Printf(p, "kvr_wager <amount> - Make a bet with your rival, winner take all!")
		end
		return
	end
	
	if p.hasbet == true then -- You've already made a bet
		printfunc(p, "You've already agreed to a bet.")
		return
	end
	
	if bet > (players[p.kvrpendingrival-1].kvrscore-1) -- Don't be cruel
		printfunc(p, "Be nice - "..players[p.kvrpendingrival-1].name.." only has "..(players[p.kvrpendingrival-1].kvrscore-1).." points to bet with!")
		return
	end

	if bet ~= 0 
	and bet < 50 then -- Cheap bets are for pussies
		printfunc(p, "Don't be cheap - Minimum bet is 50 points.")
		return
	end
	
	if bet > p.kvrscore - 1 -- No such thing as debt here
		printfunc(p, "Don't bite off more than you can chew - bet within your means.")
		return
	end
	
	
	if players[p.kvrpendingrival-1].kvrwager -- They've set a wager
	and bet ~= 0 -- We need "bet 0" to cancel bets
	and bet < p.kvrlastwager -- And attempted wager is less than your last wager
	and bet < players[p.kvrpendingrival-1].kvrwager then -- AND it's less than Rival's current wager!?
		printfunc(p, "Never retreat, never surrender. Can't bet less than your last offer ("..p.kvrlastwager..").") -- "Don't be pussy, haiyaa." ~ Uncle Roger
		return
	end
	
	p.kvrwager = bet
	p.kvrlastwager = p.kvrwager

	local str = "You've bet "..bet.." points. Awaiting "..players[p.kvrpendingrival-1].name.."\'s response."
	if players[p.kvrpendingrival-1].kvrwager and bet == 0 then
		str = "You've declined the bet."
		p.kvrwager = 0
		p.kvrlastwager = 0
		--print("Bet declined.")
	elseif players[p.kvrpendingrival-1].kvrwager == 0 and bet == 0
		str = "Bet SOMETHING - I wanna see some action!"
	elseif players[p.kvrpendingrival-1].kvrwager and players[p.kvrpendingrival-1].kvrwager == p.kvrwager then
		str = "You've accepted the bet of "..bet.." points!"
		p.hasbet = true
		players[p.kvrpendingrival-1].hasbet = true
		--print("Bet locked.")
	elseif players[p.kvrpendingrival-1].kvrwager and players[p.kvrpendingrival-1].kvrwager < p.kvrwager then
		str = "You've raised the bet to "..bet.." points! Will they accept, or raise the stakes even further?"
	elseif players[p.kvrpendingrival-1].kvrwager and players[p.kvrpendingrival-1].kvrwager > p.kvrwager and bet ~= 0 then
		str = "You've opted to go lower with "..bet.." points. Let's see if they agree."
	end
	printfunc(p, color.. str, false)
	
	if p.kvrwager ~= 0 and players[p.kvrpendingrival-1].kvrwager == 0
		str = p.name.." has made a bet of "..bet.. " points. Say \"!wager\" to see your options."
	elseif players[p.kvrpendingrival-1].kvrwager == 0 and bet == 0
		str = p.name.." tried betting 0 points. TELL THEM TO BET SOMETHING."
	elseif players[p.kvrpendingrival-1].kvrwager and p.kvrwager == 0 then
		str = p.name.." has declined the bet. Care to try again?"
		players[p.kvrpendingrival-1].kvrwager = 0
	elseif players[p.kvrpendingrival-1].kvrwager and players[p.kvrpendingrival-1].kvrwager == p.kvrwager then
		str = p.name.." has accepted your bet of "..p.kvrwager.." points!"
	elseif players[p.kvrpendingrival-1].kvrwager and players[p.kvrpendingrival-1].kvrwager < p.kvrwager then
		str = p.name.." has raised the bet to "..p.kvrwager.." points! Will you accept, or raise the stakes even further?"
	elseif players[p.kvrpendingrival-1].kvrwager and players[p.kvrpendingrival-1].kvrwager > p.kvrwager and p.kvrwager ~= 0 then
		str = p.name.." has opted to go lower with "..p.kvrwager.." points. Do you agree?"
	end
	
	chatprintf(players[p.kvrpendingrival-1], "\x88"..str, true)
end)
-------------------------------------------------------------------------------





local rivalcalc 
addHook("MapLoad", function()
	rivalcalc = false
	for p in players.iterate
		p.kvrarchrival = nil
		p.kvrsolo = nil
		p.musicset = nil
	end
end)

local rivbgm
local rivalchance
local archrivalchance
addHook("NetVars", function(net)
	rivbgm = net($)
	rivalchance = net($)
	archrivalchance = net($)
end)
addHook("ThinkFrame", function()
	if leveltime < 1 then return end
	
	if leveltime == 2 then
		rivbgm = M_RandomSong()
		rivalchance = P_RandomRange(1, 100)
		archrivalchance = P_RandomRange(1, 100)
	end
	
	for p in players.iterate
		if (p and p.valid) then
			if not (p.kvrpendingrival and players[p.kvrpendingrival-1] and players[p.kvrpendingrival-1].valid) then
				p.kvrpendingrival = 0
			end
			--if leveltime%TICRATE == 0 then
				--print(p.name.. " - "..p.kvrrival)
				--print(p.name.." - "..p.kvrpendingrival)
			--end

			if KVR_playercount() > 1 then
				if p.kvrrival ~= "none"
				and not p.kvrpendingrival
					for q in players.iterate
						if q.name == p.kvrrival
							p.kvrpendingrival = #q + 1
							if players[p.kvrpendingrival-1].kvrrival == p.name
								if leveltime%3 == 2
									chatprintf(p, "\x88"..players[p.kvrpendingrival-1].name.." is here - time to turn up the heat!")
								elseif leveltime%3 == 1
									chatprintf(p, "\x88Here comes "..players[p.kvrpendingrival-1].name.." - YOU MUST CRUSH THEM!")
								else
									chatprintf(p, "\x88Think you can keep up with "..players[p.kvrpendingrival-1].name.."? Time to find out!")
								end
							end
						end
					end
					if (p.mo and p.mo.valid) 
					and (p.kvrpendingrival and players[p.kvrpendingrival-1].mo and players[p.kvrpendingrival-1].mo.valid) then
						if p.mo.skin == players[p.kvrpendingrival-1].mo.skin then
							p.kvrditto = true
						else
							p.kvrditto = nil
						end
					end
				end
			
				if p.kvrpendingrival and players[p.kvrpendingrival-1].kvrpendingrival-1 == #p then
					p.kvrrival = tostring(players[p.kvrpendingrival-1].name)
					p.hasrival = 1
				end	
			end
		end
		if not (p.mo and p.mo.valid) then continue end
		kvr_signmaker(p)
	end


	if leveltime == 236 then
		for p in players.iterate
			if not (p.mo and p.mo.valid) then continue end
			if p.kvrpendingrival
			and (players[p.kvrpendingrival-1].kvrpendingrival and players[p.kvrpendingrival-1].kvrpendingrival-1 == #p) -- Rivalry is mutual
			and (players[p.kvrpendingrival-1].mo and players[p.kvrpendingrival-1].mo.valid and not players[p.kvrpendingrival-1].spectator) -- Rival is in-game
			and kvr_rmusic.value then
				if p.hasbet
					KVR_BetTier(p)
					if not p.musicset
						COM_BufInsertText(p, "tunes rvbet"..p.kvrbettier)
						p.musicset = true
					end
				else
					local p1 = p.mo.skin
					local p2 = players[p.kvrpendingrival-1].mo.skin
					if not p.musicset then
						if rivalchance <= kvr_rivalchance.value
							if archrivalchance <= kvr_archrivalchance.value
								if p1 == p2 -- MIRROR MATCH
									COM_BufInsertText(p, "tunes rvmirr")
									p.musicset = true
								else
									if kvr_armusic.value
										for _,v in ipairs(kvr_archrivaltable)
											if (p1 == v.pair[1] and p2 == v.pair[2])
											or (p1 == v.pair[2] and p2 == v.pair[1])
												COM_BufInsertText(p,"tunes "..v.name)
												p.musicset = true
												p.kvrarchrival = true
											end
										end
									end
							
									if not p.kvrarchrival
										for _,v in ipairs(kvr_solotable)
											if p2 == v.pair[1]
												COM_BufInsertText(p , "tunes "..v.name)
												p.kvrsolo = true
												p.musicset = true
											end
										end
										if not p.kvrsolo
											COM_BufInsertText(p,"tunes "..rivbgm)
											p.musicset = true
										end
									end
								end
							else
								COM_BufInsertText(p,"tunes "..rivbgm)
								p.musicset = true
							end
						end
					end
				end
			end
		end
	end
	if allfinished()
		if not rivalcalc
			for p in players.iterate
				if not hellavalid(p) continue end
				if not p.kvrpendingrival then continue end
				if not kvr_isrival(p, players[p.kvrpendingrival-1]) then continue end
				if (p.kvrpendingrival and players[p.kvrpendingrival-1].spectator) then continue end
				if p.realtime < players[p.kvrpendingrival-1].realtime or (not (p.pflags & PF_TIMEOVER) and (players[p.kvrpendingrival-1].pflags & PF_TIMEOVER)) and ((not p.spectator) and (not players[p.kvrpendingrival-1].spectator))then
					p.kvrrivalwins = $ + 1
					S_ChangeMusic("rivalw", false, p)
				elseif p.realtime > players[p.kvrpendingrival-1].realtime or (p.pflags & PF_TIMEOVER) and ((not p.spectator) and (not players[p.kvrpendingrival-1].spectator))then
					p.kvrrivallosses = $ + 1
					S_ChangeMusic("rivall", false, p)
				elseif p.realtime == players[p.kvrpendingrival-1].realtime then
					p.kvrrivaldraws = $ + 1
					S_ChangeMusic("rivtie", true,  p)
				end
				rivalcalc = true
			end
		end
	end
end)

addHook("IntermissionThinker", function()
	for p in players.iterate
		p.hasbet = 0
		p.kvrwager = 0
		p.kvrlastwager = 0
		p.kvrbettier = 0
	end
end)

local function kvr_rivalbonk(p, inf, source)
	if not (source and source.player) then return end
	if not (p.mo and p.mo.valid) then return end
	
	local p2
	if ((inf and inf.valid) and inf.player)
		p2 = inf.player
	end
	
	if ((source and source.valid) and source.player)
		p2 = source.player
	end
	
	if not (p2 and p2.valid) then return end
	
	if kvr_isrival(p2, p)
		if (p2.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and p2.huge))
			S_StartSound(p.mo, sfx_rvsqsh, p)
		else
			S_StartSound(p.mo, sfx_rvbonk, p)
			S_StartSound(p2.mo, sfx_rvhit, p2)
		end
	end
end
addHook("PlayerSpin", kvr_rivalbonk)
addHook("PlayerExplode", kvr_rivalbonk)
addHook("PlayerSquish", kvr_rivalbonk)